--******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

--=============  Add views to the STAR model... views are added for optimization purpose and also to join cross-schema's

USE $(DBNAME)
 GO
CREATE SCHEMA AUTHORIZATION $(STAR_SCHEMA)
GO


CREATE VIEW $(STAR_SCHEMA).VW_TASK_DETAIL (ACTUAL_WORK, ACTUAL_FINISH, ACTUAL_START, PLANNED_WORK, PLANNED_FINISH, PLANNED_START, PRIORITY, TASK_ID, URL, NAME,
ACTUAL_COST,ACTUAL_OVT_COST,ACTUAL_OVT_WORK,ACWP,BASELINE_COST,BASELINE_DURATION,BASELINE_FINISH,BASELINE_START,
BASELINE_WORK,BCWP,BCWS,CONSTRAINT_DATE,CONSTRAINT_TYPE,DEADLINE,DURATION_VARIANCE,EAC,EARLY_FINISH,EARLY_START,FINISH_VARIANCE,
LATE_FINISH,LATE_START,PERCENT_COMPLETE,PERCENT_WORK_COMPLETE,PLANNED_COST,PLANNED_DURATION,PLANNED_OVT_COST,PLANNED_OVT_WORK,REGULAR_WORK,
REMAINING_COST,REMAINING_DURATION,REMAINING_OVT_COST,REMAINING_OVT_WORK,REMAINING_WORK,START_VARIANCE,VAC,WBS_CODE,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 ( SELECT T.ACTUAL_WORK, T.ACTUAL_FINISH, T.ACTUAL_START, T.PLANNED_WORK, T.PLANNED_FINISH, T.PLANNED_START, TS.PRIORITY, T.TASK_ID, TS.URL, TS.NAME, 
 T.ACTUAL_COST,T.ACTUAL_OVT_COST,T.ACTUAL_OVT_WORK,T.ACWP,T.BASELINE_COST,T.BASELINE_DURATION,T.BASELINE_FINISH,T.BASELINE_START,
T.BASELINE_WORK,T.BCWP,T.BCWS,T.CONSTRAINT_DATE,T.CONSTRAINT_TYPE,T.DEADLINE,T.DURATION_VARIANCE,T.EAC,T.EARLY_FINISH,T.EARLY_START,T.FINISH_VARIANCE,T.
LATE_FINISH,T.LATE_START,T.PERCENT_COMPLETE,T.PERCENT_WORK_COMPLETE,T.PLANNED_COST,T.PLANNED_DURATION,T.PLANNED_OVT_COST,T.PLANNED_OVT_WORK,T.REGULAR_WORK,T.
REMAINING_COST,T.REMAINING_DURATION,T.REMAINING_OVT_COST,T.REMAINING_OVT_WORK,T.REMAINING_WORK,T.START_VARIANCE,T.VAC,T.WBS_CODE,TS.EXTERNAL_KEY1,TS.EXTERNAL_KEY2
FROM  $(NF_SCHEMA).TASK_DETAIL T JOIN  $(NF_SCHEMA).TASK TS ON TS.TASK_ID=T.TASK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).D_WEEK (DATE_ID, PERIOD_START_DATE, WEEK_OF_MONTH, WEEK_OF_YEAR, WEEK_NO, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, WEEK_OF_MONTH, WEEK_OF_YEAR, WEEK_NO, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF FROM D_DATE WHERE DAY_OF_WEEK=1)
GO
CREATE VIEW $(STAR_SCHEMA).D_WEEK_ISO (DATE_ID, PERIOD_START_DATE, WEEK_OF_MONTH, WEEK_OF_YEAR, WEEK_NO, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, WEEK_OF_MONTH_ISO, WEEK_OF_YEAR_ISO, WEEK_NO_ISO, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF FROM D_DATE WHERE DAY_OF_WEEK_ISO=1)
GO

CREATE VIEW $(STAR_SCHEMA).D_MONTH (DATE_ID, PERIOD_START_DATE, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF FROM D_DATE WHERE DAY_OF_MONTH=1)
GO
CREATE VIEW $(STAR_SCHEMA).D_QUARTER (DATE_ID, PERIOD_START_DATE, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF FROM D_DATE WHERE MONTH_OF_YEAR IN (1,4,7,10) AND DAY_OF_MONTH=1)
GO
CREATE VIEW $(STAR_SCHEMA).D_YEAR (DATE_ID, PERIOD_START_DATE, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, YEAR_OF FROM D_DATE WHERE MONTH_OF_YEAR =1 AND DAY_OF_MONTH=1)
GO
CREATE VIEW $(STAR_SCHEMA).VW_BUILD (BUILD_ID, BUILD_CLASS_ID, BUILD_CLASS_NAME,ITERATION_ID, ITERATION_NAME,TEAM_ID,TEAM_NAME,BUILD_STATE, COMPONENT_ID, COMPONENT_NAME, END_TIME, EXTERNAL_ID, NAME, REFERENCE_ID, START_TIME, STATUS, BUILD_TYPE,URL,
BASELINE_ID,BASELINE_NAME,OWNER_ID,OWNER_NAME,PROJECT_ID,PROJECT_NAME,PROJECT_TYPE_ID,PROJECT_TYPE_NAME,CREATION_DATE,WAITING_TIME,BUILDING_TIME,ENGINE,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT B.BUILD_ID, B.BUILD_CLASS_ID, BC.NAME AS BUILD_CLASS_NAME,B.ITERATION_ID, I.NAME AS ITERATION_NAME,B.TEAM_ID,T.NAME AS TEAM_NAME,B.BUILD_STATE, B.COMPONENT_ID,D1.NAME AS COMPONENT_NAME, B.END_TIME, B.EXTERNAL_ID, B.NAME, B.REFERENCE_ID, B.START_TIME, B.STATUS, B.BUILD_TYPE, B.URL,
 B.BASELINE_ID,BS.NAME AS BASELINE_NAME,B.OWNER_ID,R.FULL_NAME AS OWNER_NAME,B.PROJECT_ID,P.NAME AS PROJECT_NAME,B.PROJECT_TYPE_ID,PT.NAME AS PROJECT_TYPE_NAME,B.CREATION_DATE,B.WAITING_TIME,B.BUILDING_TIME,B.ENGINE,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2
 FROM  $(NF_SCHEMA).BUILD B 
 JOIN  $(NF_SCHEMA).BUILD_CLASSIFICATION BC ON BC.BUILD_CLASS_ID =B.BUILD_CLASS_ID
 JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=B.ITERATION_ID
 JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID=B.TEAM_ID
 JOIN  $(NF_SCHEMA).COMPONENT D1 ON D1.COMPONENT_ID=B.COMPONENT_ID 
 JOIN  $(NF_SCHEMA).PROJECT_BASELINE BS ON BS.BASELINE_ID=B.BASELINE_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID =B.OWNER_ID
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=B.PROJECT_ID
 JOIN  $(NF_SCHEMA).PROJECT_TYPE PT ON PT.PROJECT_TYPE_ID=B.PROJECT_TYPE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COMPONENT (COMPONENT_ID, EXTERNAL_ID, NAME, PRODUCT_ID, PRODUCT_NAME, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,COMPONENT_CLASS_ID,COMPONENT_CLASS_NAME,PARENT_COMPONENT_ID,PARENT_COMPONENT_NAME) AS
 (SELECT C.COMPONENT_ID, C.EXTERNAL_ID, C.NAME, C.PRODUCT_ID, D1.NAME AS PRODUCT_NAME, COALESCE(D.PROJECT_ID,-1) AS PROJECT_ID, D2.NAME AS PROJECT_NAME, C.REFERENCE_ID, C.URL,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.COMPONENT_CLASS_ID,CL.NAME AS COMPONENT_CLASS_NAME,C.PARENT_COMPONENT_ID,CP.NAME AS PARENT_COMPONENT_NAME
 FROM  $(NF_SCHEMA).COMPONENT C 
 JOIN  $(NF_SCHEMA).COMPONENT CP ON CP.COMPONENT_ID=C.PARENT_COMPONENT_ID 
 JOIN  $(NF_SCHEMA).PRODUCT D1 ON D1.PRODUCT_ID=C.PRODUCT_ID 
 LEFT JOIN  $(NF_SCHEMA).PROJECT_COMPONENT_LOOKUP D ON D.COMPONENT_ID=C.COMPONENT_ID 
 LEFT JOIN  $(NF_SCHEMA).PROJECT D2 ON D2.PROJECT_ID=D.PROJECT_ID 
 JOIN  $(NF_SCHEMA).COMPONENT_CLASSIFICATION CL ON CL.COMPONENT_CLASS_ID=C.COMPONENT_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEAM (EXTERNAL_ID, NAME, REFERENCE_ID, TEAM_ID,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT C.EXTERNAL_ID, C.NAME, C.REFERENCE_ID, C.TEAM_ID,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).TEAM C)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CURRENCY (CURRENCY_ID, DEFAULT_CURRENCY, EXCHANGE_RATE, EXTERNAL_ID, NAME, REFERENCE_ID, URL, VALID_FINISH_DATE, VALID_START_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT C.CURRENCY_ID, CASE WHEN C.DEFAULT_CURRENCY=1 THEN 'True' ELSE 'False' END AS DEFAULT_CURRENCY, C.EXCHANGE_RATE, C.EXTERNAL_ID, C.NAME, C.REFERENCE_ID, C.URL, C.VALID_FINISH_DATE, C.VALID_START_DATE,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2 
 FROM  $(NF_SCHEMA).CURRENCY C)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CUSTOMER (COMPANY_NAME, CONTACT_ADDRESS, CONTACT_EMAIL, CONTACT_FAX, CONTACT_PHONE, CUSTOMER_ID, CUST_REFID, EXTERNAL_ID, GEO_LOCATION, NAME, REFERENCE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT C.COMPANY_NAME, C.CONTACT_ADDRESS, C.CONTACT_EMAIL, C.CONTACT_FAX, C.CONTACT_PHONE, C.CUSTOMER_ID, C.CUST_REFID, C.EXTERNAL_ID, C.GEO_LOCATION, C.NAME, C.REFERENCE_ID, C.URL,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2 
 FROM  $(NF_SCHEMA).CUSTOMER C)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FACTOR (EXTERNAL_ID, FACTOR_ID, MITIGATION_COST, NAME, PRIORITY, REFERENCE_ID, RISK_ID, RISK_NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT F.EXTERNAL_ID, F.FACTOR_ID, F.MITIGATION_COST, F.NAME, F.PRIORITY, F.REFERENCE_ID, F.RISK_ID, R.NAME AS RISK_NAME, F.URL,F.EXTERNAL_KEY1,F.EXTERNAL_KEY2 
 FROM  $(NF_SCHEMA).FACTOR F JOIN  $(NF_SCHEMA).RISK R ON R.RISK_ID=F.RISK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE (EXTERNAL_ID, FILE_CLASS_ID,FILE_ID, NAME, REFERENCE_ID, URL,COMPONENT_ID,COMPONENT_NAME,NUM_SLOC,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT F.EXTERNAL_ID, F.FILE_CLASS_ID,F.FILE_ID, F.NAME, F.REFERENCE_ID, F.URL,
F. COMPONENT_ID,C.NAME AS COMPONENT_NAME,F.NUM_SLOC,F.EXTERNAL_KEY1,F.EXTERNAL_KEY2 
  FROM  $(NF_SCHEMA).[FILE] F 
  JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=F.COMPONENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE_BASELINE (EXTERNAL_ID, FILE_BASELINE_ID, NAME, REFERENCE_ID, URL,COMPONENT_ID,COMPONENT_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT F.EXTERNAL_ID, F.FILE_BASELINE_ID, F.NAME, F.REFERENCE_ID, F.URL,F.COMPONENT_ID,C.NAME AS COMPONENT_NAME,F.EXTERNAL_KEY1,F.EXTERNAL_KEY2 
 FROM  $(NF_SCHEMA).FILE_BASELINE F
 JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=F.COMPONENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE_STREAM (EXTERNAL_ID, FILE_STREAM_CLASS_ID,FILE_STREAM_ID, NAME, REFERENCE_ID, URL,PROJECT_ID,PROJECT_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT F.EXTERNAL_ID, F.FILE_STREAM_CLASS_ID,F.FILE_STREAM_ID,F.NAME, F.REFERENCE_ID, F.URL,F.PROJECT_ID,P.NAME AS PROJECT_NAME,F.EXTERNAL_KEY1,F.EXTERNAL_KEY2
 FROM  $(NF_SCHEMA).FILE_STREAM F
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=F.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RESOURCE (EXTERNAL_ID, FIRST_NAME, FULL_NAME, LAST_NAME, MIDDLE_INITIAL, NAME, RESOURCE_ID, REFERENCE_ID, URL,
OVERTIME_RATE,POOL_ID,POOL_NAME,RESOURCE_TYPE,STANDARD_RATE,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT P.EXTERNAL_ID, P.FIRST_NAME, P.FULL_NAME, P.LAST_NAME, P.MIDDLE_INITIAL, P.NAME, P.RESOURCE_ID, P.REFERENCE_ID, P.URL,
 P.OVERTIME_RATE,P.POOL_ID,PL.NAME AS POOL_NAME,P.RESOURCE_TYPE,P.STANDARD_RATE,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2
  FROM  $(NF_SCHEMA).RESOURCE P
  JOIN  $(NF_SCHEMA).POOL PL ON PL.POOL_ID=P.POOL_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PRODUCT (EXTERNAL_ID, NAME, PRODUCT_ID, REFERENCE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT P.EXTERNAL_ID, P.NAME, P.PRODUCT_ID, P.REFERENCE_ID, P.URL,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).PRODUCT P)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT (EXTERNAL_ID, NAME, PROJECT_ID, PROJECT_MANAGER, MANAGER_NAME, REFERENCE_ID, URL,
END_DATE,START_DATE,PROJECT_CATEGORY_ID,PROJECT_CATEGORY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,PROJECT_CLASS_ID,PROJECT_CLASS_NAME,SHIP_DATE) AS
 (SELECT  P.EXTERNAL_ID, P.NAME, P.PROJECT_ID, P.PROJECT_MANAGER,R.FULL_NAME AS MANAGER_NAME, P.REFERENCE_ID, P.URL,
 P.END_DATE,P.START_DATE,P.PROJECT_CATEGORY_ID,PC.NAME AS PROJECT_CATEGORY_NAME,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2,P.PROJECT_CLASS_ID,PL.NAME AS PROJECT_CLASS_NAME,P.SHIP_DATE
  FROM  $(NF_SCHEMA).PROJECT P 
  JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=P.PROJECT_MANAGER
  JOIN  $(NF_SCHEMA).PROJECT_CATEGORY PC ON PC.PROJECT_CATEGORY_ID=P.PROJECT_CATEGORY_ID
  JOIN  $(NF_SCHEMA).PROJECT_CLASSIFICATION PL ON PL.PROJECT_CLASS_ID=P.PROJECT_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_DETAIL (ACTUAL_BUDGET, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, BAC, BASELINE_COST, BASELINE_ESTIMATED_COST, BASELINE_ESTIMATED_FINISH, BASELINE_ESTIMATED_START, BASELINE_FINISH, BASELINE_START, BASELINE_VARIANCE, BCWP, BCWS, CURRENCY_ID, CURRENT_BUDGET, EAC, EV_ETC, EV_FLAG, PLANNED_BUDGET, PLANNED_FINISH, PLANNED_START, PROJECT_ID, PROJECT_NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT  P.ACTUAL_BUDGET, P.ACTUAL_FINISH, P.ACTUAL_START, P.ACTUAL_VARIANCE, P.ACWP, P.BAC, P.BASELINE_COST, P.BASELINE_ESTIMATED_COST, P.BASELINE_ESTIMATED_FINISH, P.BASELINE_ESTIMATED_START, P.BASELINE_FINISH, P.BASELINE_START, P.BASELINE_VARIANCE, P.BCWP, P.BCWS, P.CURRENCY_ID, P.CURRENT_BUDGET, P.EAC, P.EV_ETC, P.EV_FLAG, P.PLANNED_BUDGET, P.PLANNED_FINISH, P.PLANNED_START, P.PROJECT_ID,R.NAME AS PROJECT_NAME, R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2 
 FROM  $(NF_SCHEMA).PROJECT_DETAIL P JOIN  $(NF_SCHEMA).PROJECT R ON R.PROJECT_ID=P.PROJECT_ID)
GO
 
CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_CATEGORY (PROJECT_CATEGORY_ID, EXTERNAL_ID, REFERENCE_ID, NAME, PROJECT_ID, PROJECT_NAME, CATEGORY_TYPE, OWNER_ID, MANAGER_NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT PC.PROJECT_CATEGORY_ID, PC.EXTERNAL_ID, PC.REFERENCE_ID, PC.NAME, P.PROJECT_ID, P.NAME AS PROJECT_NAME, PC.CATEGORY_TYPE, PC.OWNER_ID,R.FULL_NAME AS MANAGER_NAME, PC.URL,PC.EXTERNAL_KEY1,PC.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).PROJECT_CATEGORY PC JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PC.OWNER_ID JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_CATEGORY_ID=PC.PROJECT_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PHASE (PHASE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, STATUS, START_DATE, END_DATE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT PP.PHASE_ID, PP.NAME, PP.REFERENCE_ID, PP.EXTERNAL_ID, PP.PROJECT_ID, P.NAME AS PROJECT_NAME, PP.STATUS, PP.START_DATE, PP.END_DATE , PP.URL,PP.EXTERNAL_KEY1,PP.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).PHASE PP JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PP.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ITERATION (ITERATION_ID, NAME, REFERENCE_ID, EXTERNAL_ID, ASSETREGISTRY_ID,ASSETREGISTRY_NAME,PROJECT_ID, PROJECT_NAME,PHASE_ID, PHASE_NAME,OWNER_ID,OWNER_NAME,STATUS, START_DATE, END_DATE, EXPECTED_START_DATE, EXPECTED_END_DATE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,EXPECTED_TOTAL_POINTS,EXPECTED_DEFECTS,EXPECTED_VALIDITY_RATE) AS
 (SELECT I.ITERATION_ID, I.NAME, I.REFERENCE_ID, I.EXTERNAL_ID, I.ASSETREGISTRY_ID,A.NAME,I.PROJECT_ID, P.NAME AS PROJECT_NAME,I.PHASE_ID,PH.NAME,I.OWNER_ID,R.FULL_NAME AS OWNER_NAME,I.STATUS, I.START_DATE, I.END_DATE , I.EXPECTED_START_DATE, I.EXPECTED_END_DATE,I.URL,I.EXTERNAL_KEY1,I.EXTERNAL_KEY2,
I.EXPECTED_TOTAL_POINTS,I.EXPECTED_DEFECTS,I.EXPECTED_VALIDITY_RATE 
FROM  $(NF_SCHEMA).ITERATION I 
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=I.PROJECT_ID
 JOIN  $(NF_SCHEMA).PHASE PH ON PH.PHASE_ID=I.PHASE_ID
  JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=I.OWNER_ID
 JOIN  $(NF_SCHEMA).ASSETREGISTRY A ON A.ASSETREGISTRY_ID=I.ASSETREGISTRY_ID)
GO
 
CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_ROLE (PROJECT_ROLE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, OWNER_ID, MANAGER_NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT PR.PROJECT_ROLE_ID, PR.NAME, PR.REFERENCE_ID, PR.EXTERNAL_ID, PR.PROJECT_ID, P.NAME AS PROJECT_NAME, PR.OWNER_ID,R.FULL_NAME AS MANAGER_NAME, PR.URL,PR.EXTERNAL_KEY1,PR.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).PROJECT_ROLE PR JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PR.OWNER_ID JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PR.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_WORKCONFIGURATION (PROJECT_WKCFG_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, RECORD_TYPE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT PWC.PROJECT_WKCFG_ID, PWC.NAME, PWC.REFERENCE_ID, PWC.EXTERNAL_ID, PWC.PROJECT_ID, P.NAME AS PROJECT_NAME, PWC.RECORD_TYPE, PWC.URL,PWC.EXTERNAL_KEY1,PWC.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).PROJECT_WORKCONFIGURATION PWC JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PWC.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_TYPE (PROJECT_TYPE_ID, EXTERNAL_ID, REFERENCE_ID, NAME, PROJECT_ID, PROJECT_NAME, PROJECT_WKCFG_ID, PROJECT_WORKCONFIGURATION_NAME, RECORD_TYPE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT PT.PROJECT_TYPE_ID, PT.EXTERNAL_ID, PT.REFERENCE_ID, PT.NAME, PT.PROJECT_ID, P.NAME AS PROJECT_NAME, PWC.PROJECT_WKCFG_ID, PWC.NAME AS PROJECT_WORKCONFIGURATION_NAME, PT.RECORD_TYPE, PT.URL,PT.EXTERNAL_KEY1,PT.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).PROJECT_TYPE PT JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PT.PROJECT_ID JOIN  $(NF_SCHEMA).PROJECT_WORKCONFIGURATION PWC ON P.PROJECT_ID=PWC.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTIVITY (ACTIVITY_ID, EXTERNAL_ID, REFERENCE_ID, NAME, TASK_ID, TASK_NAME,OWNER_ID, OWNER_FULLNAME, FAILED_BUILD, VALIDATION_BUILD, NOTEST_BUILD, FILE_STREAM_ID, FILE_STREAM_NAME, RESOLUTION_CODE, URL,
ACTIVITY_STATE,ACTIVITY_TYPE,CREATION_DATE,PRIORITY,PROJECT_ID,PROJECT_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,ACTIVITY_CLASS_ID,ACTIVITY_CLASS_NAME,STATUS,RESOLUTION) AS
(SELECT A.ACTIVITY_ID, A.EXTERNAL_ID, A.REFERENCE_ID, A.NAME, A.TASK_ID, T.NAME AS TASK_NAME,A.OWNER_ID,R.FULL_NAME AS OWNER_FULLNAME, A.FAILED_BUILD, A.VALIDATION_BUILD, A.NOTEST_BUILD, A.FILE_STREAM_ID, S.NAME AS FILE_STREAM_NAME, A.RESOLUTION_CODE, A.URL,
A.ACTIVITY_STATE,A.ACTIVITY_TYPE,A.CREATION_DATE,A.PRIORITY,A.PROJECT_ID,P.NAME AS PROJECT_NAME,A.EXTERNAL_KEY1,A.EXTERNAL_KEY2,A.ACTIVITY_CLASS_ID,AC.NAME AS ACTIVITY_CLASS_NAME,A.STATUS,A.RESOLUTION
 FROM  $(NF_SCHEMA).ACTIVITY A 
 JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=A.TASK_ID 
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=A.OWNER_ID 
 JOIN  $(NF_SCHEMA).FILE_STREAM S ON S.FILE_STREAM_ID=A.FILE_STREAM_ID
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=A.PROJECT_ID
 JOIN  $(NF_SCHEMA).ACTIVITY_CLASSIFICATION AC ON AC.ACTIVITY_CLASS_ID=A.ACTIVITY_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_ACTIVITY_LOOKUP (REQUEST_ID,REQUEST_NAME,ACTIVITY_ID,ACTIVITY_NAME) AS
(SELECT RA.REQUEST_ID, R.NAME AS REQUEST_NAME,RA.ACTIVITY_ID, A.NAME AS ACTIVITY_NAME
FROM  $(NF_SCHEMA).REQUEST_ACTIVITY_LOOKUP RA
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID =RA.REQUEST_ID
JOIN  $(NF_SCHEMA). ACTIVITY A ON A.ACTIVITY_ID=RA.ACTIVITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COMMENT (COMMENT_ID, RESPONSE_COMMENT_ID, REQUEST_ID, REQUEST_NAME, TASK_ID, TASK_NAME, ACTIVITY_ID, ACTIVITY_NAME, OWNER_ID, AUTHOR, CREATION_DATE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT C.COMMENT_ID, C.RESPONSE_COMMENT_ID, C.REQUEST_ID, CR.NAME AS REQUEST_NAME, C.TASK_ID, T.NAME AS TASK_NAME, C.ACTIVITY_ID, A.NAME AS ACTIVITY_NAME, C.OWNER_ID, R.FULL_NAME AS AUTHOR, C.CREATION_DATE, C.URL,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).COMMENT C JOIN  $(NF_SCHEMA).REQUEST CR ON CR.REQUEST_ID=C.REQUEST_ID JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=C.TASK_ID JOIN  $(NF_SCHEMA).ACTIVITY A ON A.ACTIVITY_ID=C.ACTIVITY_ID JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=C.OWNER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RELEASE (AVAILABILITY_DATE, DECOMISSION_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, NAME, PRODUCT_ID, PRODUCT_NAME, REFERENCE_ID, RELEASE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PROJECT_ID,PROJECT_NAME) AS
 (SELECT R.AVAILABILITY_DATE, R.DECOMISSION_DATE, R.EXTERNAL_ID, R.ITERATION_ID, I.NAME AS ITERATION_NAME, R.NAME, R.PRODUCT_ID, P.NAME AS PRODUCT_NAME, R.REFERENCE_ID, R.RELEASE_ID, R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.PROJECT_ID,PR.NAME AS PROJECT_NAME 
 FROM  $(NF_SCHEMA).RELEASE R 
 JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=R.ITERATION_ID 
 JOIN  $(NF_SCHEMA).PROJECT PR ON PR.PROJECT_ID=R.PROJECT_ID
 JOIN  $(NF_SCHEMA).PRODUCT P ON P.PRODUCT_ID=R.PRODUCT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST (ACTIVATE_DATE, ASSIGNED_DATE, CLOSED_DATE, COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DUPLICATE_DATE, EXTERNAL_ID, FIXEDINRELEASE_ID, FIXED_IN_RELEASE_NAME, IS_BLOCKING, ITERATION_ID, ITERATION_NAME, NAME, PLATFORM, PRIORITY, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, FOUND_IN_RELEASE_NAME, REQUEST_CLASS_ID, REQUEST_TYPE_NAME, REQUEST_ID, OWNER_ID, REQUEST_RESPONSIBLE, REQUEST_SOURCE, REQUEST_STATE, RESOLUTION, RESOLVED_DATE, SEVERITY, SLOC_CHANGE, STATUS, SUBMIT_DATE, URL,
BUILD_ID,BUILD_NAME,PHASE_ID,PHASE_NAME,PROJECT_CATEGORY_ID, PROJECT_CATEGORY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,REQUEST_TYPE,REQUEST_CATEGORY_ID,REQUEST_CATEGORY_NAME) AS
 (SELECT R.ACTIVATE_DATE, R.ASSIGNED_DATE, R.CLOSED_DATE, R.COMPONENT_ID,C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DUPLICATE_DATE, R.EXTERNAL_ID, R.FIXEDINRELEASE_ID,RL.NAME AS FIXED_IN_RELEASE_NAME, R.IS_BLOCKING, R.ITERATION_ID,I.NAME AS ITERATION_NAME, R.NAME, R.PLATFORM, R.PRIORITY, R.PROJECT_ID, PJ.NAME AS PROJECT_NAME,R.REFERENCE_ID, R.RELEASE_ID, RL2.NAME AS FOUND_IN_RELEASE_NAME, R.REQUEST_CLASS_ID,RQ.NAME AS REQUEST_TYPE_NAME, R.REQUEST_ID, R.OWNER_ID,PS.FULL_NAME AS REQUEST_RESPONSIBLE, R.REQUEST_SOURCE, R.REQUEST_STATE, R.RESOLUTION, R.RESOLVED_DATE, R.SEVERITY, R.SLOC_CHANGE, R.STATUS, R.SUBMIT_DATE, R.URL,
 R.BUILD_ID,B.NAME AS BUILD_NAME,R.PHASE_ID,PH.NAME AS PHASE_NAME,R.PROJECT_CATEGORY_ID,PC.NAME AS PROJECT_CATEGORY_NAME,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REQUEST_TYPE,R.REQUEST_CATEGORY_ID,RC.NAME AS REQUEST_CATEGORY_NAME
  FROM  $(NF_SCHEMA).REQUEST R 
  JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=R.ITERATION_ID 
  JOIN  $(NF_SCHEMA).PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID 
  JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=R.COMPONENT_ID 
  JOIN  $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.FIXEDINRELEASE_ID 
  JOIN  $(NF_SCHEMA).RELEASE RL2 ON RL2.RELEASE_ID=R.RELEASE_ID 
  JOIN  $(NF_SCHEMA).REQUEST_CLASSIFICATION RQ ON RQ.REQUEST_CLASS_ID=R.REQUEST_CLASS_ID
  JOIN  $(NF_SCHEMA).REQUEST_CATEGORY RC ON RC.REQUEST_CATEGORY_ID=R.REQUEST_CATEGORY_ID
  JOIN  $(NF_SCHEMA).BUILD B ON B.BUILD_ID=R.BUILD_ID
  JOIN  $(NF_SCHEMA).PHASE PH ON PH.PHASE_ID=R.PHASE_ID
  JOIN  $(NF_SCHEMA).PROJECT_CATEGORY PC ON PC.PROJECT_CATEGORY_ID=R.PROJECT_CATEGORY_ID
  JOIN  $(NF_SCHEMA).RESOURCE PS ON PS.RESOURCE_ID=R.OWNER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT (COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DIFFICULTY, EXTERNAL_ID, NAME, PLATFORM, PRIORITY, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, RELEASE_NAME, REQUIREMENT_CLASS_ID, REQUIREMENT_CLASS_NAME, REQUIREMENT_ID, OWNER_ID, RESPONSIBLE_NAME, REQUIREMENT_STATE, REVISION_NUMBER, STABILITY, STATUS, URL,
ACTUAL_ITERATION_ID,ACTUAL_ITERATION_NAME,PLANNED_ITERATION_ID,PLANNED_ITERATION_NAME,REQUIREMENT_TYPE,REVISION_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT R.COMPONENT_ID, C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DIFFICULTY, R.EXTERNAL_ID, R.NAME, R.PLATFORM, R.PRIORITY, R.PROJECT_ID, PJ.NAME AS PROJECT_NAME, R.REFERENCE_ID, R.RELEASE_ID, RL.NAME AS RELEASE_NAME, R.REQUIREMENT_CLASS_ID, RC.NAME AS REQUIREMENT_CLASS_NAME, R.REQUIREMENT_ID, R.OWNER_ID,P.FULL_NAME AS RESPONSIBLE_NAME, R.REQUIREMENT_STATE, R.REVISION_NUMBER, R.STABILITY, R.STATUS, R.URL,
 R.ACTUAL_ITERATION_ID,AC.NAME AS ACTUAL_ITERATION_NAME,R.PLANNED_ITERATION_ID,PL.NAME AS PLANNED_ITERATION_NAME,R.REQUIREMENT_TYPE,R.REVISION_DATE,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2
  FROM  $(NF_SCHEMA).REQUIREMENT R 
  JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =R.COMPONENT_ID 
  JOIN  $(NF_SCHEMA).PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID 
  JOIN  $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID 
  JOIN  $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION RC ON RC.REQUIREMENT_CLASS_ID=R.REQUIREMENT_CLASS_ID 
  JOIN  $(NF_SCHEMA).RESOURCE P ON P.RESOURCE_ID=R.OWNER_ID
  JOIN  $(NF_SCHEMA).ITERATION AC ON AC.ITERATION_ID=R.ACTUAL_ITERATION_ID
  JOIN  $(NF_SCHEMA).ITERATION PL ON PL.ITERATION_ID=R.PLANNED_ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_CUSTOMER_LOOKUP (REQUIREMENT_ID, NAME, CUSTOMER_ID, CUSTOMER_NAME) AS
 ( SELECT R.REQUIREMENT_ID, R1.NAME,R.CUSTOMER_ID,C.NAME AS CUSTOMER_NAME FROM  $(NF_SCHEMA).REQUIREMENT_CUSTOMER_LOOKUP R JOIN  $(NF_SCHEMA).REQUIREMENT R1 ON R1.REQUIREMENT_ID=R.REQUIREMENT_ID JOIN  $(NF_SCHEMA).CUSTOMER C ON C.CUSTOMER_ID=R.CUSTOMER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK (PRIORITY,TASK_TYPE,EXTERNAL_ID, NAME, REFERENCE_ID, TASK_ID, PROJECT_ID, PROJECT_NAME, OWNER_ID, TASK_RESPONSIBLE_NAME, TASK_STATE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,TASK_CLASS_ID,TASK_CLASS_NAME, ITERATION_ID,ITERATION_NAME,STATUS,RESOLUTION) AS
 ( SELECT T.PRIORITY,T.TASK_TYPE,T.EXTERNAL_ID, T.NAME, T.REFERENCE_ID, T.TASK_ID, T.PROJECT_ID, P.NAME AS PROJECT_NAME, T.OWNER_ID, PR.FULL_NAME AS TASK_RESPONSIBLE_NAME, T.TASK_STATE, T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TASK_CLASS_ID,TL.NAME AS TASK_CLASS_NAME,T.ITERATION_ID,I.NAME AS ITERATION_NAME,T.STATUS,T.RESOLUTION FROM  $(NF_SCHEMA).TASK T JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID JOIN  $(NF_SCHEMA).RESOURCE PR ON PR.RESOURCE_ID=T.OWNER_ID JOIN  $(NF_SCHEMA).TASK_CLASSIFICATION TL ON TL.TASK_CLASS_ID=T.TASK_CLASS_ID JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=T.ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITELOG (BUILD_ID, TESTSUITELOG_NAME,END_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, REFERENCE_ID, START_DATE, TESTSUITELOG_ID, TESTSUITE_ID, TESTSUITE_NAME, URL, VERDICT,OWNER_ID, OWNER_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITELOG_CLASS_ID,TESTSUITELOG_CLASS_NAME) AS
 (SELECT S.BUILD_ID, S.NAME AS TESTSUITELOG_NAME, S.END_DATE, S.EXTERNAL_ID, S.ITERATION_ID,I.NAME AS ITERATION_NAME, S.REFERENCE_ID, S.START_DATE, S.TESTSUITELOG_ID, S.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME, S.URL, S.VERDICT,S.OWNER_ID,R.FULL_NAME AS  OWNER_NAME ,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.TESTSUITELOG_CLASS_ID,TL.NAME AS TESTSUITELOG_CLASS_NAME  
 FROM  $(NF_SCHEMA).TESTSUITELOG S 
 JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=S.ITERATION_ID 
 JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=S.TESTSUITE_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=S.OWNER_ID
 JOIN  $(NF_SCHEMA).TESTSUITELOG_CLASSIFICATION TL ON TL.TESTSUITELOG_CLASS_ID=S.TESTSUITELOG_CLASS_ID)
GO
  
CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE (EXTERNAL_ID, IS_BLOCKING, NAME, REFERENCE_ID, TESTCASE_ID, TESTCASE_STATE, TESTPLAN_ID, TESTPLAN_NAME, URL,OWNER_ID,OWNER_NAME,
REGRESSION_TEST,WEIGHT,LAST_UPDATED,COMPONENT_ID,COMPONENT_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTCASE_CLASS_ID,TESTCASE_CLASS_NAME,TESTCASE_FOLDER,PROJECT_ID,PROJECT_NAME) AS
(SELECT T.EXTERNAL_ID, T.IS_BLOCKING, T.NAME, T.REFERENCE_ID, T.TESTCASE_ID, T.TESTCASE_STATE, T.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME, T.URL,T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.REGRESSION_TEST,T.WEIGHT,T.LAST_UPDATED,
T.COMPONENT_ID,C.NAME AS COMPONENT_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTCASE_CLASS_ID,TL.NAME AS TESTCASE_CLASS_NAME,T.TESTCASE_FOLDER,T.PROJECT_ID,P.NAME AS PROJECT_NAME 
 FROM  $(NF_SCHEMA).TESTCASE T 
 JOIN  $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=T.TESTPLAN_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
 JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=T.COMPONENT_ID
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
 JOIN  $(NF_SCHEMA).TESTCASE_CLASSIFICATION TL ON TL.TESTCASE_CLASS_ID=T.TESTCASE_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECUTION_RESULT (BUILD_ID, BUILD_NAME,NAME, LAST_UPDATED, END_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, REFERENCE_ID, START_DATE, EXECUTION_RESULT_ID, URL, VERDICT,
TESTTYPE_ID, TESTTYPE_NAME,TESCASE_ID,TESTCASE_NAME,PROJECT_ID,PROJECT_NAME,CREATION_DATE,
POINTS_BLOCKED,POINTS_INCONCLUSIVE,MACHINE,POINTS_ATTEMPTED,POINTS_FAILED,POINTS_PASSED,POINTS_PERMFAILED,EXTERNAL_KEY1,EXTERNAL_KEY2,EXECRES_CLASS_ID,EXECRES_CLASS_NAME) AS
(SELECT T.BUILD_ID,B.NAME AS BUILD_NAME,T.NAME,T.LAST_UPDATED, T.END_DATE, T.EXTERNAL_ID, T.ITERATION_ID,I.NAME AS ITERATION_NAME, T.REFERENCE_ID, T.START_DATE, T.EXECUTION_RESULT_ID, T.URL, T.VERDICT,
T.TESTTYPE_ID,TT.NAME AS TESTTYPE_NAME,T.TESTCASE_ID,TC.NAME AS TESTCASE_NAME,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE,
T.POINTS_BLOCKED,T.POINTS_INCONCLUSIVE,T.MACHINE,T.POINTS_ATTEMPTED,T.POINTS_FAILED,T.POINTS_PASSED,T.POINTS_PERMFAILED,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.EXECRES_CLASS_ID,TL.NAME AS EXECRES_CLASS_NAME
FROM  $(NF_SCHEMA).EXECUTION_RESULT T 
JOIN  $(NF_SCHEMA).BUILD B ON B.BUILD_ID=T.BUILD_ID 
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=T.ITERATION_ID
JOIN  $(NF_SCHEMA).TESTCASE TC ON TC.TESTCASE_ID=T.TESTCASE_ID
JOIN  $(NF_SCHEMA).TESTTYPE TT ON TT.TESTTYPE_ID=T.TESTTYPE_ID
JOIN  $(NF_SCHEMA).EXECRESULT_CLASSIFICATION TL ON TL.EXECRES_CLASS_ID=T.EXECRES_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN (EXTERNAL_ID, NAME, REFERENCE_ID, TESTPLAN_ID, TESTPLAN_STATE,PROJECT_ID,PROJECT_NAME,CREATION_DATE,OWNER_ID,OWNER_NAME,LAST_UPDATED,URL,ASSETREGISTRY_ID,ASSETREGISTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTPLAN_CLASS_ID,TESTPLAN_CLASS_NAME) AS
 (SELECT T.EXTERNAL_ID, T.NAME, T.REFERENCE_ID, T.TESTPLAN_ID, T.TESTPLAN_STATE,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE, 
T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.LAST_UPDATED,T.URL,T.ASSETREGISTRY_ID,A.NAME AS ASSETREGISTRY_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTPLAN_CLASS_ID,TL.NAME AS TESTPLAN_CLASS_NAME
FROM  $(NF_SCHEMA).TESTPLAN T
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
JOIN  $(NF_SCHEMA).ASSETREGISTRY A ON A.ASSETREGISTRY_ID=T.ASSETREGISTRY_ID
JOIN  $(NF_SCHEMA).TESTPLAN_CLASSIFICATION TL ON TL.TESTPLAN_CLASS_ID=T.TESTPLAN_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE (EXTERNAL_ID, NAME, REFERENCE_ID, TESTSUITE_ID, TESTSUITE_STATE, URL, LAST_UPDATED,PROJECT_ID,PROJECT_NAME,CREATION_DATE,OWNER_ID, OWNER_NAME,CONFIGURATION_ID,CONFIGURATION_NAME,ASSETREGISTRY_ID,ASSETREGISTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITE_CLASS_ID,TESTSUITE_CLASS_NAME) AS
 (SELECT T.EXTERNAL_ID, T.NAME, T.REFERENCE_ID, T.TESTSUITE_ID, T.TESTSUITE_STATE, T.URL,T.LAST_UPDATED,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE,
 T.OWNER_ID, R.FULL_NAME AS OWNER_NAME,T.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,T.ASSETREGISTRY_ID,A.NAME AS ASSETREGISTRY_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTSUITE_CLASS_ID,TL.NAME AS TESTSUITE_CLASS_NAME
 FROM  $(NF_SCHEMA).TESTSUITE T
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
 JOIN  $(NF_SCHEMA).CONFIGURATION C ON C.CONFIGURATION_ID =T.CONFIGURATION_ID
 JOIN  $(NF_SCHEMA).ASSETREGISTRY A ON A.ASSETREGISTRY_ID=T.ASSETREGISTRY_ID
 JOIN  $(NF_SCHEMA).TESTSUITE_CLASSIFICATION TL ON TL.TESTSUITE_CLASS_ID=T.TESTSUITE_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECWORKITEM_ITER_LOOKUP (EXECWORKITEM_ID, EXECUTION_WORKITEM_NAME, ITERATION_ID, ITERATION_NAME) AS
 (SELECT  CI.EXECWORKITEM_ID, C.NAME AS EXECUTION_WORKITEM_NAME, CI.ITERATION_ID, I.NAME AS ITERATION_NAME FROM  $(NF_SCHEMA).EXECWORKITEM_ITERATION_LOOKUP CI JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM C ON C.EXECWORKITEM_ID=CI.EXECWORKITEM_ID JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=CI.ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECWORKITEM_TSTSUTE_LOOKUP (EXECWORKITEM_ID, EXECUTION_WORKITEM_NAME, TESTSUITE_ID, TESTSUITE_NAME) AS
 (SELECT  CT.EXECWORKITEM_ID, C.NAME AS EXECUTION_WORKITEM_NAME, CT.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME FROM  $(NF_SCHEMA).EXECWORKITEM_TESTSUITE_LOOKUP CT JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM C ON C.EXECWORKITEM_ID=CT.EXECWORKITEM_ID JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=CT.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_CUSTOMER_LOOKUP (CUSTOMER_ID, CUSTOMER_NAME, REQUEST_ID, REQUEST_NAME) AS
 (SELECT  RC.CUSTOMER_ID, C.NAME AS CUSTOMER_NAME, RC.REQUEST_ID, R.NAME AS REQUEST_NAME FROM  $(NF_SCHEMA).REQUEST_CUSTOMER_LOOKUP RC JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=RC.REQUEST_ID JOIN  $(NF_SCHEMA).CUSTOMER C ON C.CUSTOMER_ID=RC.CUSTOMER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIR_EXECWRKITEM_LOOKUP (EXECWORKITEM_ID, EXECUTION_WORKITEM_NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RC.EXECWORKITEM_ID, C.NAME AS EXECUTION_WORKITEM_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME FROM  $(NF_SCHEMA).REQUIREMENT_EXECWRKITEM_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM C ON C.EXECWORKITEM_ID=RC.EXECWORKITEM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_REQUEST_LOOKUP (REQUEST_ID, REQUEST_NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RC.REQUEST_ID, C.NAME AS REQUEST_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME FROM   $(NF_SCHEMA).REQUIREMENT_REQUEST_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).REQUEST C ON C.REQUEST_ID=RC.REQUEST_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_TESTCASE_LOOKUP (TESTCASE_ID, TESTCASE_NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RC.TESTCASE_ID, C.NAME AS TESTCASE_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME FROM   $(NF_SCHEMA).REQUIREMENT_TESTCASE_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).TESTCASE C ON C.TESTCASE_ID=RC.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_TESTPLAN_LOOKUP (TESTPLAN_ID, TESTPLAN_NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RC.TESTPLAN_ID, C.NAME AS TESTPLAN_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME FROM   $(NF_SCHEMA).REQUIREMENT_TESTPLAN_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).TESTPLAN C ON C.TESTPLAN_ID=RC.TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_TSTSUITE_LOOKUP (TESTSUITE_ID, TESTSUITE_NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RC.TESTSUITE_ID, C.NAME AS TESTSUITE_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME FROM   $(NF_SCHEMA).REQUIREMENT_TESTSUITE_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).TESTSUITE C ON C.TESTSUITE_ID=RC.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE_ITERATION_LOOKUP (ITERATION_ID, ITERATION_NAME, TESTCASE_ID, TESTCASE_NAME) AS
 (SELECT  RT.ITERATION_ID, I.NAME AS ITERATION_NAME, RT.TESTCASE_ID, T.NAME AS TESTCASE_NAME FROM  $(NF_SCHEMA).TESTCASE_ITERATION_LOOKUP RT JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=RT.ITERATION_ID JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=RT.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECRES_REQUEST_LOOKUP (REQUEST_ID, REQUEST_NAME, EXECUTION_RESULT_ID, EXECUTION_RESULT_VERDICT) AS
 (SELECT TR.REQUEST_ID, I.NAME AS REQUEST_NAME, TR.EXECUTION_RESULT_ID, T.VERDICT AS EXECUTION_RESULT_VERDICT FROM  $(NF_SCHEMA).EXECRES_REQUEST_LOOKUP TR JOIN  $(NF_SCHEMA).REQUEST I ON I.REQUEST_ID=TR.REQUEST_ID JOIN  $(NF_SCHEMA).EXECUTION_RESULT T ON T.EXECUTION_RESULT_ID=TR.EXECUTION_RESULT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_ITERATION_LOOKUP (ITERATION_ID, ITERATION_NAME, TESTPLAN_ID, TESTPLAN_NAME) AS
 (SELECT  RT.ITERATION_ID, I.NAME AS ITERATION_NAME, RT.TESTPLAN_ID, T.NAME AS TESTPLAN_NAME FROM  $(NF_SCHEMA).TESTPLAN_ITERATION_LOOKUP RT JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=RT.ITERATION_ID JOIN  $(NF_SCHEMA).TESTPLAN T ON T.TESTPLAN_ID=RT.TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_ITERATION_LOOKUP (ITERATION_ID, ITERATION_NAME, TESTSUITE_ID, TESTSUITE_NAME) AS
 (SELECT  RT.ITERATION_ID, I.NAME AS ITERATION_NAME, RT.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME FROM  $(NF_SCHEMA).TESTSUITE_ITERATION_LOOKUP RT JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=RT.ITERATION_ID JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=RT.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITELOG_EXECRES_LOOKUP (TESTSUITELOG_ID, TESTSUITELOG_VERDICT, EXECUTION_RESULT_ID, EXECUTION_RESULT_VERDICT) AS
 (SELECT ST.TESTSUITELOG_ID, S.VERDICT AS TESTSUITELOG_VERDICT, ST.EXECUTION_RESULT_ID, T.VERDICT AS EXECUTION_RESULT_VERDICT FROM  $(NF_SCHEMA).TESTSUITELOG_EXECRESULT_LOOKUP ST JOIN  $(NF_SCHEMA).TESTSUITELOG S ON S.TESTSUITELOG_ID=ST.TESTSUITELOG_ID JOIN  $(NF_SCHEMA).EXECUTION_RESULT T ON T.EXECUTION_RESULT_ID=ST.EXECUTION_RESULT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_REQUEST_LOOKUP (REQUEST_ID, REQUEST_NAME, TASK_ID, TASK_NAME) AS
 ( SELECT  TR.REQUEST_ID, R.NAME AS REQUEST_NAME, TR.TASK_ID, T.NAME AS TASK_NAME FROM  $(NF_SCHEMA).TASK_REQUEST_LOOKUP TR JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=TR.REQUEST_ID JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=TR.TASK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_REQUIREMENT_LOOKUP (REQUIREMENT_ID, REQUIREMENT_NAME, TASK_ID, TASK_NAME) AS
 ( SELECT  TR.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME, TR.TASK_ID, T.NAME AS TASK_NAME FROM  $(NF_SCHEMA).TASK_REQUIREMENT_LOOKUP TR JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=TR.REQUIREMENT_ID JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=TR.TASK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE_VERSION (CREATION_DATE, FILE_CLASS_ID,EXTERNAL_ID, FILE_VERSION_ID, NAME, NUM_SLOC, REFERENCE_ID, URL,
ACTIVITY_ID,ACTIVITY_NAME,AUTHOR_ID,AUTHOR_NAME,FILE_ID,FILE_NAME,FILE_STREAM_ID,FILE_STREAM_NAME,HASCOMMENT,NUM_SLOC_CHANGED,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
( SELECT C.CREATION_DATE, C.FILE_CLASS_ID,C.EXTERNAL_ID, C.FILE_VERSION_ID, C.NAME, C.NUM_SLOC, C.REFERENCE_ID, C.URL,
C.ACTIVITY_ID,A.NAME AS ACTIVITY_NAME,C.AUTHOR_ID,R.FULL_NAME AS AUTHOR_NAME,C.FILE_ID,F.NAME AS FILE_NAME,C.FILE_STREAM_ID,FS.NAME AS FILE_STREAM_NAME,C.HASCOMMENT,C.NUM_SLOC_CHANGED,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2
 FROM  $(NF_SCHEMA).FILE_VERSION C
 JOIN  $(NF_SCHEMA).ACTIVITY A ON A.ACTIVITY_ID=C.ACTIVITY_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=C.AUTHOR_ID
 JOIN  $(NF_SCHEMA).[FILE] F ON F.FILE_ID=C.FILE_ID
 JOIN  $(NF_SCHEMA).FILE_STREAM FS ON FS.FILE_STREAM_ID=C.FILE_STREAM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_BASELINE (BASELINE_ID, EXTERNAL_ID, FILE_STREAM_ID, FILE_NAME, NAME, OWNER_ID, PROJECT_ID, REFERENCE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT P.BASELINE_ID, P.EXTERNAL_ID, P.FILE_STREAM_ID,F.NAME AS FILE_NAME, P.NAME, P.OWNER_ID, P.PROJECT_ID, P.REFERENCE_ID, P.URL,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2 FROM  $(NF_SCHEMA).PROJECT_BASELINE P JOIN  $(NF_SCHEMA).FILE_STREAM F ON F.FILE_STREAM_ID=P.FILE_STREAM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID,NAME) AS (SELECT ACTIVITY_CLASS_ID,NAME FROM  $(NF_SCHEMA).ACTIVITY_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTIVITY_DETAIL (ACTIVITY_ID,ACTIVITY_NAME,ACTUAL_COST,ACTUAL_FINISH,ACTUAL_OVT_COST,ACTUAL_OVT_WORK,ACTUAL_START,ACTUAL_WORK,ACWP,BASELINE_COST,BASELINE_FINISH,BASELINE_START,BASELINE_WORK,BCWP,BCWS,DELAY,EAC,EXTERNAL_ID,FINISH_VARIANCE,IS_CONFIRMED,IS_OVERALLOCATED,OWNER_ID,OWNER_NAME,PLANNED_COST,PLANNED_FINISH,PLANNED_OVT_WORK,PLANNED_START,PLANNED_WORK,REFERENCE_ID,REGULAR_WORK,REMAINING_COST,REMAINING_OVT_COST,REMAINING_OVT_WORK,REMAINING_WORK,RESOURCE_TYPE,START_VARIANCE,TASK_ID,TASK_NAME,UNITS,URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS 
(SELECT A.ACTIVITY_ID,AA.NAME AS ACTIVITY_NAME,A.ACTUAL_COST,A.ACTUAL_FINISH,A.ACTUAL_OVT_COST,A.ACTUAL_OVT_WORK,A.ACTUAL_START,A.ACTUAL_WORK,A.ACWP,A.BASELINE_COST,A.BASELINE_FINISH,A.BASELINE_START,A.BASELINE_WORK,A.BCWP,A.BCWS,A.DELAY,A.EAC,AA.EXTERNAL_ID,A.FINISH_VARIANCE,A.IS_CONFIRMED,A.IS_OVERALLOCATED,AA.OWNER_ID,R.FULL_NAME AS OWNER_NAME,A.PLANNED_COST,A.PLANNED_FINISH,A.PLANNED_OVT_WORK,A.PLANNED_START,A.PLANNED_WORK,AA.REFERENCE_ID,A.REGULAR_WORK,A.REMAINING_COST,A.REMAINING_OVT_COST,A.REMAINING_OVT_WORK,A.REMAINING_WORK,A.RESOURCE_TYPE,A.START_VARIANCE,AA.TASK_ID,T.NAME AS TASK_NAME,A.UNITS,AA.URL,AA.EXTERNAL_KEY1,AA.EXTERNAL_KEY2
FROM  $(NF_SCHEMA).ACTIVITY_DETAIL A
JOIN  $(NF_SCHEMA).ACTIVITY AA ON A.ACTIVITY_ID=AA.ACTIVITY_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=AA.OWNER_ID
JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=AA.TASK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSETREGISTRY (ASSETREGISTRY_ID,EXTERNAL_ID,NAME,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT A.ASSETREGISTRY_ID,A.EXTERNAL_ID,A.NAME,A.REFERENCE_ID,A.URL,A.EXTERNAL_KEY1,A.EXTERNAL_KEY2
FROM  $(NF_SCHEMA).ASSETREGISTRY A)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIGURATION(CONFIGURATION_ID,EXTERNAL_ID,NAME,REFERENCE_ID,URL,LAST_UPDATED,OWNER_ID,OWNER_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,CONFIGURATION_CLASS_ID,CONFIGURATION_CLASS_NAME,PROJECT_ID,PROJECT_NAME) AS 
(SELECT C.CONFIGURATION_ID,C.EXTERNAL_ID,C.NAME,C.REFERENCE_ID,C.URL,C.LAST_UPDATED,C.OWNER_ID,R.FULL_NAME AS OWNER_NAME,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.CONFIGURATION_CLASS_ID,CL.NAME AS CONFIGURATION_CLASS_NAME,C.PROJECT_ID,P.NAME AS PROJECT_NAME
FROM  $(NF_SCHEMA).CONFIGURATION C
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=C.OWNER_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=C.PROJECT_ID
JOIN  $(NF_SCHEMA).CONFIGURATION_CLASSIFICATION CL ON CL.CONFIGURATION_CLASS_ID=C.CONFIGURATION_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIGURATION_ATTRIBUTE(CONFIGURATION_ATTRIBUTE_ID,EXTERNAL_ID,NAME,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT CONFIGURATION_ATTRIBUTE_ID,EXTERNAL_ID,NAME,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2
FROM  $(NF_SCHEMA).CONFIGURATION_ATTRIBUTE)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIGURATION_ATTR_LOOKUP(CONFIGURATION_ATTRIBUTE_ID,CONFIGURATION_ATTRIBUTE_NAME,CONFIGURATION_ID,CONFIGURATION_NAME) AS 
(SELECT C.CONFIGURATION_ATTRIBUTE_ID,CFA.NAME AS CONFIGURATION_ATTRIBUTE_NAME,C.CONFIGURATION_ID,CF.NAME AS CONFIGURATION_NAME
FROM  $(NF_SCHEMA).CONFIGURATION_ATTRIBUTE_LOOKUP C
JOIN  $(NF_SCHEMA).CONFIGURATION_ATTRIBUTE CFA ON CFA.CONFIGURATION_ATTRIBUTE_ID=C.CONFIGURATION_ATTRIBUTE_ID
JOIN  $(NF_SCHEMA).CONFIGURATION CF ON CF.CONFIGURATION_ID=C.CONFIGURATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIG_EXECUTIONRES_LOOKUP(EXECUTION_RESULT_ID,CONFIGURATION_ID,CONFIGURATION_NAME) AS 
(SELECT C.EXECUTION_RESULT_ID,C.CONFIGURATION_ID,CF.NAME AS CONFIGURATION_NAME
FROM  $(NF_SCHEMA).CONFIG_EXECUTIONRES_LOOKUP C
JOIN  $(NF_SCHEMA).CONFIGURATION CF ON CF.CONFIGURATION_ID=C.CONFIGURATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECUTION_WORKITEM (EXECWORKITEM_ID,CONFIGURATION_ID,CONFIGURATION_NAME,EXECUTION_WORKITEM_STATE,EXTERNAL_ID,NAME,OWNER_ID,OWNER_NAME,PRIORITY,PROJECT_ID,PROJECT_NAME,REFERENCE_ID,TESTCASE_ID,TESTCASE_NAME,TESTTYPE_ID,TESTTYPE_NAME,URL,TESTPLAN_ID,TESTPLAN_NAME,FREQUENCY,REGRESSION,WEIGHT,LAST_UPDATED,CURRENT_RESULT_ID,CURRENT_RESULT_NAME,CURRENT_RESULT_VERDICT,TAGS,EXTERNAL_KEY1,EXTERNAL_KEY2,EXECWORKIT_CLASS_ID,EXECWORKIT_CLASS_NAME,CREATION_DATE) AS
(SELECT C.EXECWORKITEM_ID,C.CONFIGURATION_ID,CF.NAME AS CONFIGURATION_NAME,C.EXECUTION_WORKITEM_STATE,C.EXTERNAL_ID,C.NAME,C.OWNER_ID,R.FULL_NAME AS OWNER_NAME,C.PRIORITY,C.PROJECT_ID,P.NAME AS PROJECT_NAME,C.REFERENCE_ID,C.TESTCASE_ID,T.NAME AS TESTCASE_NAME,C.TESTTYPE_ID,TT.NAME AS TESTTYPE_NAME, C.URL,C.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,C.FREQUENCY,C.REGRESSION,C.WEIGHT,C.LAST_UPDATED,C.CURRENT_RESULT_ID,ER.NAME AS CURRENT_RESULT_NAME,ER.VERDICT AS CURRENT_RESULT_VERDICT,C.TAGS,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.EXECWORKIT_CLASS_ID,EL.NAME AS EXECWORKIT_CLASS_NAME,C.CREATION_DATE
FROM  $(NF_SCHEMA).EXECUTION_WORKITEM C
JOIN  $(NF_SCHEMA).CONFIGURATION CF ON CF.CONFIGURATION_ID=C.CONFIGURATION_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=C.OWNER_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=C.PROJECT_ID
JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=C.TESTCASE_ID
JOIN  $(NF_SCHEMA).TESTTYPE TT ON TT.TESTTYPE_ID=C.TESTTYPE_ID
JOIN  $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=C.TESTPLAN_ID
JOIN  $(NF_SCHEMA).EXECUTION_RESULT ER ON ER.EXECUTION_RESULT_ID=C.CURRENT_RESULT_ID
JOIN  $(NF_SCHEMA).EXECWORKITEM_CLASSIFICATION EL ON EL.EXECWORKIT_CLASS_ID=C.EXECWORKIT_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_POOL (EXTERNAL_ID,NAME,POOL_ID,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT EXTERNAL_ID,NAME,POOL_ID,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2 FROM  $(NF_SCHEMA).POOL)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJ_BASELN_BASELN_LOOKUP(BASELINE_ID,BASELINE_NAME,COMPBASELINE_ID,COMPBASELINE_NAME) AS 
(SELECT BL.BASELINE_ID,B.NAME,BL.COMPBASELINE_ID, C.NAME
FROM  $(NF_SCHEMA).PROJ_BASELINE_BASELINE_LOOKUP BL
JOIN  $(NF_SCHEMA).PROJECT_BASELINE B ON B.BASELINE_ID=BL.BASELINE_ID
JOIN  $(NF_SCHEMA).PROJECT_BASELINE C ON C.BASELINE_ID=BL.COMPBASELINE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_CLASSIFICATION (NAME,PROJECT_CLASS_ID) AS
(SELECT NAME,PROJECT_CLASS_ID FROM  $(NF_SCHEMA).PROJECT_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_COMPONENT_LOOKUP(COMPONENT_ID,COMPONENT_NAME,PROJECT_ID,PROJECT_NAME) AS
(SELECT CP.COMPONENT_ID,C.NAME AS COMPONENT_NAME,CP.PROJECT_ID,P.NAME AS PROJECT_NAME
FROM  $(NF_SCHEMA).PROJECT_COMPONENT_LOOKUP CP
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=CP.COMPONENT_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=CP.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_HIERARCHY(CHILD_PROJECT_ID,CHILD_PROJECT_NAME,PARENT_PROJECT_ID,PARENT_PROJECT_NAME) AS 
(SELECT BL.CHILD_PROJECT_ID,B.NAME,BL.PARENT_PROJECT_ID, C.NAME
FROM  $(NF_SCHEMA).PROJECT_HIERARCHY BL
JOIN  $(NF_SCHEMA).PROJECT B ON B.PROJECT_ID=BL.CHILD_PROJECT_ID
JOIN  $(NF_SCHEMA).PROJECT C ON C.PROJECT_ID=BL.PARENT_PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_WRKCONFIG_HIERARCHY(PARENT_WKCFG_ID,PARENT_WKCFG_NAME,CHILD_WKCFG_ID,CHILD_WKCFG_NAME) AS 
(SELECT BL.PARENT_WKCFG_ID,B.NAME,BL.CHILD_WKCFG_ID, C.NAME
FROM  $(NF_SCHEMA).PROJECT_WORKCONFIG_HIERARCHY BL
JOIN  $(NF_SCHEMA).PROJECT_WORKCONFIGURATION B ON B.PROJECT_WKCFG_ID=BL.PARENT_WKCFG_ID
JOIN  $(NF_SCHEMA).PROJECT_WORKCONFIGURATION C ON C.PROJECT_WKCFG_ID=BL.CHILD_WKCFG_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_ROLE_MEMBER_LOOKUP(PROJECT_ROLE_ID,PROJECT_NAME,RESOURCE_ID,FULL_NAME) AS
(SELECT PR.PROJECT_ROLE_ID,P.NAME,PR.RESOURCE_ID,R.FULL_NAME
FROM  $(NF_SCHEMA).PROJECT_ROLE_MEMBER_LOOKUP PR 
JOIN  $(NF_SCHEMA).PROJECT_ROLE P ON P.PROJECT_ROLE_ID=PR.PROJECT_ROLE_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PR.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_CLASSIFICATION (NAME,REQUEST_CLASS_ID) AS
(SELECT NAME,REQUEST_CLASS_ID FROM  $(NF_SCHEMA).REQUEST_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COMPONENT_CLASSIFICATION (NAME,COMPONENT_CLASS_ID) AS
(SELECT NAME,COMPONENT_CLASS_ID FROM  $(NF_SCHEMA).COMPONENT_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_HIERARCHY (CHILD_REQUEST_ID,CHILD_REQUEST_NAME,PARENT_REQUEST_ID,PARENT_REQUEST_NAME) AS
(SELECT RC.CHILD_REQUEST_ID,C.NAME AS CHILD_REQUEST_NAME,RC.PARENT_REQUEST_ID,P.NAME AS PARENT_REQUEST_NAME
FROM  $(NF_SCHEMA).REQUEST_HIERARCHY RC 
JOIN  $(NF_SCHEMA).REQUEST C ON C.REQUEST_ID=RC.CHILD_REQUEST_ID
JOIN  $(NF_SCHEMA).REQUEST P ON P.REQUEST_ID=RC.PARENT_REQUEST_ID)
GO


CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_HIERARCHY (PRED_REQUIREMENT_ID,PRED_REQUIREMENT_NAME,SUCC_REQUIREMENT_ID,SUCC_REQUIREMENT_NAME) AS
(SELECT RC.PRED_REQUIREMENT_ID,C.NAME AS PRED_REQUIREMENT_NAME,RC.SUCC_REQUIREMENT_ID,P.NAME AS SUCC_REQUIREMENT_NAME
FROM  $(NF_SCHEMA).REQUIREMENT_HIERARCHY RC 
JOIN  $(NF_SCHEMA).REQUIREMENT C ON C.REQUIREMENT_ID=RC.PRED_REQUIREMENT_ID
JOIN  $(NF_SCHEMA).REQUIREMENT P ON P.REQUIREMENT_ID=RC.SUCC_REQUIREMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIRE_REQUIRE_LOOKUP (CREQUIREMENT_ID,CREQUIREMENT_NAME,REQUIREMENT_ID,REQUIREMENT_NAME) AS
(SELECT RR.CREQUIREMENT_ID,C.NAME AS CREQUIREMENT_NAME,RR.REQUIREMENT_ID,R.NAME AS REQUIREMENT_NAME
FROM  $(NF_SCHEMA).REQUIREMENT_REQUIREMENT_LOOKUP RR
JOIN  $(NF_SCHEMA).REQUIREMENT C ON C.REQUIREMENT_ID=RR.CREQUIREMENT_ID
JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RR.REQUIREMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_CLASSIFICATION (NAME,REQUIREMENT_CLASS_ID) AS
(SELECT NAME,REQUIREMENT_CLASS_ID FROM  $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_CLASSIFICATION (NAME,TASK_CLASS_ID) AS
(SELECT NAME,TASK_CLASS_ID FROM  $(NF_SCHEMA).TASK_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_STATE_HISTORY(CHANGE_DATE,DAYS_IN_STATE,REQUEST_ID,REQUEST_NAME,PREV_REQUEST_STATE,REQUEST_STATE,REQUEST_STATE_HISTORY_ID,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT H.CHANGE_DATE,DAYS_IN_STATE, H.REQUEST_ID,R.NAME AS REQUEST_NAME, H.PREV_REQUEST_STATE,H.REQUEST_STATE, H.REQUEST_STATE_HISTORY_ID,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2 
FROM  $(NF_SCHEMA).REQUEST_STATE_HISTORY H
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=H.REQUEST_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_REVISION_HIST(CHANGE_DATE,REQUIREMENT_ID,REQUIREMENT_NAME,REQUIREMENT_REVISION_ID,RESOURCE_ID,FULL_NAME,REVISION_NUMBER,EXTERNAL_KEY1,EXTERNAL_KEY2) AS 
(SELECT H.CHANGE_DATE,H.REQUIREMENT_ID,RE.NAME AS REQUIREMENT_NAME,H.REQUIREMENT_REVISION_ID,H.RESOURCE_ID,R.FULL_NAME,H.REVISION_NUMBER,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2
FROM  $(NF_SCHEMA).REQUIREMENT_REVISION_HISTORY H
JOIN  $(NF_SCHEMA).REQUIREMENT RE ON RE.REQUIREMENT_ID=H.REQUIREMENT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=H.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_CATEGORY (CATEGORY_TYPE,NAME,OWNER_ID,FULL_NAME,REFERENCE_ID,TASK_CATEGORY_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT T.CATEGORY_TYPE,T.NAME,T.OWNER_ID,R.FULL_NAME,T.REFERENCE_ID,T.TASK_CATEGORY_ID,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2
FROM  $(NF_SCHEMA).TASK_CATEGORY T
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTTYPE (NAME,REFERENCE_ID,TESTTYPE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT NAME,REFERENCE_ID,TESTTYPE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2
FROM  $(NF_SCHEMA).TESTTYPE)
GO 

CREATE VIEW $(STAR_SCHEMA).VW_FILE_BASELINE_ACT_LOOKUP (FILE_BASELINE_ID,FILE_BASELINE_NAME,ACTIVITY_ID,ACTIVITY_NAME) AS
(SELECT FB.FILE_BASELINE_ID,F.NAME AS FILE_BASELINE_NAME,FB.ACTIVITY_ID,A.NAME AS ACTIVITY_NAME
FROM  $(NF_SCHEMA).FILE_BASELINE_ACTIVITY_LOOKUP FB
JOIN  $(NF_SCHEMA).FILE_BASELINE F ON F.FILE_BASELINE_ID=FB.FILE_BASELINE_ID
JOIN  $(NF_SCHEMA).ACTIVITY A ON A.ACTIVITY_ID=FB.ACTIVITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEST_CATEGORY (TEST_CATEGORY_ID,VALUE,TERM, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT TEST_CATEGORY_ID,TERM,VALUE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2 FROM  $(NF_SCHEMA).TEST_CATEGORY)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECRES_EXECWKITEM_LOOKUP (EXECUTION_RESULT_ID,EXECUTION_RESULT_NAME, EXECWORKITEM_ID,EXECWORKITEM_NAME) AS
(SELECT ERL.EXECUTION_RESULT_ID,ER.NAME AS EXECUTION_RESULT_NAME, ERL.EXECWORKITEM_ID,EW.NAME AS EXECWORKITEM_NAME
FROM  $(NF_SCHEMA).EXECRES_EXECWKITEM_LOOKUP ERL
JOIN  $(NF_SCHEMA).EXECUTION_RESULT ER ON ER.EXECUTION_RESULT_ID=ERL.EXECUTION_RESULT_ID
JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM EW ON EW.EXECWORKITEM_ID=ERL.EXECWORKITEM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIG_EXECWORKITM_LOOKUP (CONFIGURATION_ID,CONFIGURATION_NAME,EXECWORKITEM_ID,EXECWORKITEM_NAME) AS
(SELECT CEL.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,CEL.EXECWORKITEM_ID,E.NAME AS EXECWORKITEM_NAME
FROM  $(NF_SCHEMA).CONFIG_EXECUTIONWORKITM_LOOKUP CEL
JOIN  $(NF_SCHEMA).CONFIGURATION C ON C.CONFIGURATION_ID=CEL.CONFIGURATION_ID
JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM E ON E.EXECWORKITEM_ID=CEL.EXECWORKITEM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_CATEGORY_LOOKUP (TESPLAN_ID,TESTPLAN_NAME,TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
(SELECT TCL.TESTPLAN_ID,T.NAME AS TESTPLAN_NAME,TCL.TEST_CATEGORY_ID,C.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).TESTPLAN_CATEGORY_LOOKUP TCL
JOIN  $(NF_SCHEMA).TESTPLAN T ON T.TESTPLAN_ID=TCL.TESTPLAN_ID
JOIN  $(NF_SCHEMA).TEST_CATEGORY C ON C.TEST_CATEGORY_ID=TCL.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE_CATEGORY_LOOKUP (TESTCASE_ID,TESTCASE_NAME,TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
(SELECT TCL.TESTCASE_ID,T.NAME AS TESTCASE_NAME,TCL.TEST_CATEGORY_ID,C.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).TESTCASE_CATEGORY_LOOKUP TCL
JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=TCL.TESTCASE_ID
JOIN  $(NF_SCHEMA).TEST_CATEGORY C ON C.TEST_CATEGORY_ID=TCL.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_TESTCASE_LOOKUP (TESTCASE_ID,TESTCASE_NAME,TESTSUITE_ID, TESTSUITE_NAME) AS
(SELECT TCL.TESTCASE_ID,T.NAME AS TESTCASE_NAME,TCL.TESTSUITE_ID,C.NAME AS TESTSUITE_NAME
FROM  $(NF_SCHEMA).TESTSUITE_TESTCASE_LOOKUP TCL
JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=TCL.TESTCASE_ID
JOIN  $(NF_SCHEMA).TESTSUITE C ON C.TESTSUITE_ID=TCL.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_TSUITELOG_LOOKUP (TESTSUITELOG_ID,TESTSUITELOG_NAME,TESTSUITE_ID, TESTSUITE_NAME) AS
(SELECT TCL.TESTSUITELOG_ID,T.NAME AS TESTSUITELOG_NAME,TCL.TESTSUITE_ID,C.NAME AS TESTSUITE_NAME
FROM  $(NF_SCHEMA).TESTSUITE_TESTSUITELOG_LOOKUP TCL
JOIN  $(NF_SCHEMA).TESTSUITELOG T ON T.TESTSUITELOG_ID=TCL.TESTSUITELOG_ID
JOIN  $(NF_SCHEMA).TESTSUITE C ON C.TESTSUITE_ID=TCL.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_TESTPLAN_HIERARCHY (PARENT_TESTPLAN_ID,PARENT_TESTPLAN_NAME,CHILD_TESTPLAN_ID,CHILD_TESTPLAN_NAME) AS 
(SELECT H.PARENT_TESTPLAN_ID,P.NAME AS PARENT_TESTPLAN_NAME, H.CHILD_TESTPLAN_ID,C.NAME AS CHILD_TESTPLAN_NAME
FROM  $(NF_SCHEMA).TESTPLAN_TESTPLAN_HIERARCHY H
JOIN  $(NF_SCHEMA).TESTPLAN P ON P.TESTPLAN_ID=H.PARENT_TESTPLAN_ID
JOIN  $(NF_SCHEMA).TESTPLAN C ON C.TESTPLAN_ID=H.CHILD_TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_TESTCASE_LOOKUP (TESTPLAN_ID, TESTPLAN_NAME,TESTCASE_ID, TESTCASE_NAME) AS 
(SELECT TT.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,TT.TESTCASE_ID,TL.NAME AS TESTCASE_NAME
FROM  $(NF_SCHEMA).TESTPLAN_TESTCASE_LOOKUP TT
JOIN  $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=TT.TESTPLAN_ID
JOIN  $(NF_SCHEMA).TESTCASE TL ON TL.TESTCASE_ID=TT.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_LAB_RESOURCE (LAB_RESOURCE_ID,NAME,SOFTWARE,REFERENCE_ID,LAB_RESOURCE_TYPE,LAB_RESOURCE_NAME,MEMORY,
IP_ADDRESS,PRIMARY_MAC_ADDRESS,ADMINISTRATIVE_STATUS,OPERATIONAL_STATUS,HOSTNAME,FULLY_QUALIFIED_DOMAIN_NAME,
OS_TYPE,OS_LOCALE,OS_KERNEL_WIDTH,CPU_SPEED,CPU_ARCHITECTURE,CPU_ARCHITECTURE_WIDTH,CPU_MANUFACTURER,CPU_TYPE, 
DISK_SPACE,RESOURCE_GROUP_ID,RESOURCE_GROUP_NAME,PROJECT_ID, PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT L.LAB_RESOURCE_ID,L.NAME,L.SOFTWARE,L.REFERENCE_ID,L.LAB_RESOURCE_TYPE,L.LAB_RESOURCE_NAME,L.MEMORY,
L.IP_ADDRESS,L.PRIMARY_MAC_ADDRESS,L.ADMINISTRATIVE_STATUS,L.OPERATIONAL_STATUS,L.HOSTNAME,L.FULLY_QUALIFIED_DOMAIN_NAME,
L.OS_TYPE,L.OS_LOCALE,L.OS_KERNEL_WIDTH,L.CPU_SPEED,L.CPU_ARCHITECTURE,L.CPU_ARCHITECTURE_WIDTH,L.CPU_MANUFACTURER,L.CPU_TYPE, 
L.DISK_SPACE,L.RESOURCE_GROUP_ID,R.NAME AS RESOURCE_GROUP_NAME,L.PROJECT_ID, P.NAME AS PROJECT_NAME,L.URL,L.EXTERNAL_KEY1,L.EXTERNAL_KEY2
FROM  $(NF_SCHEMA).LAB_RESOURCE L
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=L.PROJECT_ID
JOIN  $(NF_SCHEMA).RESOURCE_GROUP R
ON R.RESOURCE_GROUP_ID=L.RESOURCE_GROUP_ID)
GO
CREATE VIEW $(STAR_SCHEMA).VW_RESOURCE_GROUP (RESOURCE_GROUP_ID,NAME,REFERENCE_ID,EXTERNAL_ID,IS_EXPIREABLE,START_DATE,EXPIRATION_DATE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PROJECT_ID,PROJECT_NAME) AS
(SELECT R.RESOURCE_GROUP_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.IS_EXPIREABLE,R.START_DATE,R.EXPIRATION_DATE,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.PROJECT_ID,P.NAME AS PROJECT_NAME
FROM  $(NF_SCHEMA).RESOURCE_GROUP R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RESERVATION (RESERVATION_ID,NAME,REFERENCE_ID,RESERVED_FOR,RESERVED_BY,RESERVE_TO,
RESERVE_FROM,LAB_RESOURCE_ID,LAB_RESOURCE_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PROJECT_ID,PROJECT_NAME) AS 
(SELECT R.RESERVATION_ID,R.NAME,R.REFERENCE_ID,R.RESERVED_FOR,R.RESERVED_BY,R.RESERVE_TO,
R.RESERVE_FROM,R.LAB_RESOURCE_ID,L.LAB_RESOURCE_NAME,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.PROJECT_ID,P.NAME AS PROJECT_NAME
FROM  $(NF_SCHEMA).RESERVATION R
JOIN  $(NF_SCHEMA).LAB_RESOURCE L
ON L.LAB_RESOURCE_ID=R.LAB_RESOURCE_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VWCONFIGURATION_CLASSIFICATION(CONFIGURATION_CLASS_ID,NAME) AS (SELECT CONFIGURATION_CLASS_ID,NAME FROM  $(NF_SCHEMA).CONFIGURATION_CLASSIFICATION)
GO 
CREATE VIEW $(STAR_SCHEMA).VW_EXECRESULT_CLASSIFICATION (EXECRES_CLASS_ID,NAME) AS (SELECT EXECRES_CLASS_ID,NAME FROM  $(NF_SCHEMA).EXECRESULT_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_EXECWORKITEM_CLASSIFICATION (EXECWORKIT_CLASS_ID,NAME) AS (SELECT EXECWORKIT_CLASS_ID,NAME FROM  $(NF_SCHEMA).EXECWORKITEM_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID,NAME) AS (SELECT TESTCASE_CLASS_ID,NAME FROM  $(NF_SCHEMA).TESTCASE_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_CLASSIFICATION (TESTPLAN_CLASS_ID,NAME) AS (SELECT TESTPLAN_CLASS_ID,NAME FROM  $(NF_SCHEMA).TESTPLAN_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_CLASSIFICATION (TESTSUITE_CLASS_ID,NAME) AS (SELECT TESTSUITE_CLASS_ID,NAME FROM  $(NF_SCHEMA).TESTSUITE_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITELOG_CLASSIFICATION (TESTSUITELOG_CLASS_ID,NAME) AS (SELECT TESTSUITELOG_CLASS_ID,NAME FROM  $(NF_SCHEMA).TESTSUITELOG_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_CATEGORY (REQUEST_CATEGORY_ID, EXTERNAL_ID, REFERENCE_ID, NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
 (SELECT REQUEST_CATEGORY_ID, EXTERNAL_ID, REFERENCE_ID, NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2 FROM  $(NF_SCHEMA).REQUEST_CATEGORY)
GO
 
CREATE VIEW $(STAR_SCHEMA).VW_FILE_CLASSIFICATION (FILE_CLASS_ID,NAME) AS (SELECT FILE_CLASS_ID,NAME FROM  $(NF_SCHEMA).FILE_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_FILE_STREAM_CLASSIFICATION (FILE_STREAM_CLASS_ID,NAME) AS (SELECT FILE_STREAM_CLASS_ID,NAME FROM  $(NF_SCHEMA).FILE_STREAM_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_BUILD_CLASSIFICATION (BUILD_CLASS_ID,NAME) AS (SELECT BUILD_CLASS_ID,NAME FROM  $(NF_SCHEMA).BUILD_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_CHANGE_HISTORY
(REQCHANGE_HISTORY_ID,REQUEST_CLASS_ID, REQUEST_CLASS_NAME,REQUEST_ID,NAME,PREV_TEAM_ID, TEAM_NAME,                          
PREV_REQUEST_CATEGORY_ID, PREV_REQUEST_CATEGORY_NAME,PREV_ITERATION_ID, PREV_ITERATION_NAME,PREV_OWNER_ID,PREV_OWNER_NAME,
CHANGE_DATE,PREV_REQUEST_TYPE ,PREV_STATE,PREV_PRIORITY,PREV_SEVERITY,PREV_COMMENT_COUNT,PREV_SUBSCRIBER_COUNT,
PREV_TAGS,PREV_PLANNED_WORK,PREV_ACTUAL_WORK,PREV_STORY_POINTS,URL,EXTERNAL_KEY1,EXTERNAL_KEY2)
AS
(SELECT H.REQCHANGE_HISTORY_ID,H.REQUEST_CLASS_ID,RC.NAME AS REQUEST_CLASS_NAME,H.REQUEST_ID, R.NAME,H.PREV_TEAM_ID,P.NAME AS TEAM_NAME,
H.PREV_REQUEST_CATEGORY_ID, RN.NAME AS PREV_REQUEST_CATEGORY_NAME,
H.PREV_ITERATION_ID,I.NAME AS PREV_ITERATION_NAME,
H.PREV_OWNER_ID, O.FULL_NAME AS PREV_OWNER_NAME,H.CHANGE_DATE,H.PREV_REQUEST_TYPE,H.PREV_STATE,
H.PREV_PRIORITY,H.PREV_SEVERITY,H.PREV_COMMENT_COUNT,H.PREV_SUBSCRIBER_COUNT,H.PREV_TAGS,H.PREV_PLANNED_WORK,
H.PREV_ACTUAL_WORK,H.PREV_STORY_POINTS,H.URL,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2
FROM  $(NF_SCHEMA).REQUEST_CHANGE_HISTORY H
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=H.REQUEST_ID
JOIN  $(NF_SCHEMA).REQUEST_CLASSIFICATION RC ON RC.REQUEST_CLASS_ID=H.REQUEST_CLASS_ID
JOIN  $(NF_SCHEMA).TEAM P ON P.TEAM_ID =H.PREV_TEAM_ID
JOIN  $(NF_SCHEMA).REQUEST_CATEGORY RN ON RN.REQUEST_CATEGORY_ID=H.PREV_REQUEST_CATEGORY_ID
JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=H.PREV_ITERATION_ID
JOIN  $(NF_SCHEMA).RESOURCE O ON O.RESOURCE_ID=H.PREV_OWNER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_BUILD_COMPILATION_RESULT	(BUILD_COMPRES_ID,BUILD_ID,NAME,COMPONENT_ID,COMPONENT_NAME,COMPILE_ERROR_COUNT,COMPILE_WARNING_COUNT,EXTERNAL_KEY1,EXTERNAL_KEY2,URL) AS  
SELECT B.BUILD_COMPRES_ID,B.BUILD_ID,BL.NAME,B.COMPONENT_ID,C.NAME AS COMPONENT_NAME,B.COMPILE_ERROR_COUNT,B.COMPILE_WARNING_COUNT,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2,B.URL
FROM  $(NF_SCHEMA).BUILD_COMPILATION_RESULT B
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =B.COMPONENT_ID
JOIN  $(NF_SCHEMA).BUILD BL ON BL.BUILD_ID =B.BUILD_ID
GO

CREATE VIEW $(STAR_SCHEMA).VW_BUILD_UNIT_RESULT	(BUILD_UNITRES_ID,BUILD_ID,NAME,COMPONENT_ID,COMPONENT_NAME,UNIT_TEST_COUNT,UNIT_FAILURE_COUNT,UNIT_ERROR_COUNT,EXTERNAL_KEY1,EXTERNAL_KEY2 ,URL)AS        
SELECT B.BUILD_UNITRES_ID,B.BUILD_ID,BL.NAME,B.COMPONENT_ID,C.NAME AS COMPONENT_NAME,B.UNIT_TEST_COUNT,B.UNIT_FAILURE_COUNT,B.UNIT_ERROR_COUNT,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2 ,B.URL
FROM  $(NF_SCHEMA).BUILD_UNIT_RESULT B
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =B.COMPONENT_ID
JOIN  $(NF_SCHEMA).BUILD BL ON BL.BUILD_ID =B.BUILD_ID
GO

CREATE VIEW $(STAR_SCHEMA).VW_BUILD_UNIT_EVENT (BUILD_UNIT_EVENT_ID ,BUILD_ID,NAME,COMPONENT_ID,COMPONENT_NAME,UNIT_EVENT,UNIT_TEST,EXTERNAL_KEY1,EXTERNAL_KEY2 ,URL) AS
SELECT B.BUILD_UNIT_EVENT_ID ,B.BUILD_ID,BL.NAME,B.COMPONENT_ID,C.NAME AS COMPONENT_NAME,B.UNIT_EVENT,B.UNIT_TEST,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2 ,B.URL
FROM  $(NF_SCHEMA).BUILD_UNIT_EVENT B
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =B.COMPONENT_ID
JOIN  $(NF_SCHEMA).BUILD BL ON BL.BUILD_ID =B.BUILD_ID
GO

CREATE VIEW $(STAR_SCHEMA).VW_UNIT_TEST_RESULT (UNIT_TEST_RESULT_ID ,PROJECT_ID,PROJECT_NAME,TEAM_ID,TEAM_NAME,BUILD_TYPE,COMPONENT_ID,COMPONENT_NAME,UNIT_EVENT,UNIT_TEST,UNIT_COUNT,LAST_RUN_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2 ,URL)AS  
SELECT B.UNIT_TEST_RESULT_ID ,B.PROJECT_ID,P.NAME AS PROJECT_NAME,B.TEAM_ID,T.NAME AS TEAM_NAME,BUILD_TYPE,B.COMPONENT_ID,C.NAME AS COMPONENT_NAME,B.UNIT_EVENT,B.UNIT_TEST,B.UNIT_COUNT,B.LAST_RUN_DATE,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2 ,B.URL
FROM  $(NF_SCHEMA).UNIT_TEST_RESULT B
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =B.COMPONENT_ID
JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID =B.TEAM_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =B.PROJECT_ID
GO

CREATE VIEW $(STAR_SCHEMA).VW_RISK (RISK_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,REQUIREMENT_ID,REQUIREMENT_NAME,PRIORITY,RISK_STATE,OCCURED_DATETIME ,
IMPACT_RANK,PROBABILITY_RANK,OWNER_ID,OWNER_NAME,RELEASE_ID,RELEASE_NAME,ITERATION_ID,ITERATION_NAME,TARGET_DATE ,CREATION_DATE ,CLOSE_DATE ,
IMPACT_CATEGORY,CONSEQUENCE_COST,RISK_MANAGEMENT_ACTION,URL,EXTERNAL_KEY1,EXTERNAL_KEY2) AS 
(SELECT R.RISK_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.REQUIREMENT_ID,RQ.NAME AS REQUIREMENT_NAME,R.PRIORITY,R.RISK_STATE,R.OCCURED_DATETIME ,
R.IMPACT_RANK,R.PROBABILITY_RANK,R.OWNER_ID,RE.FULL_NAME AS OWNER_NAME,R.RELEASE_ID,RL.NAME AS RELEASE_NAME,R.ITERATION_ID,I.NAME AS ITERATION_NAME,R.TARGET_DATE ,R.CREATION_DATE ,R.CLOSE_DATE ,
R.IMPACT_CATEGORY,R.CONSEQUENCE_COST,R.RISK_MANAGEMENT_ACTION,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2
FROM  $(NF_SCHEMA).RISK R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID
JOIN  $(NF_SCHEMA).REQUIREMENT RQ ON RQ.REQUIREMENT_ID=R.REQUIREMENT_ID
JOIN  $(NF_SCHEMA).RESOURCE RE ON RE.RESOURCE_ID = R.OWNER_ID
JOIN  $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID
JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID =R.ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_JOB (JOB_ID,REFERENCE_ID,EXTERNAL_ID,NAME,OWNER_ID,OWNER_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,URL,PROJECT_ID,PROJECT_NAME) AS
(SELECT J.JOB_ID,J.REFERENCE_ID,J.EXTERNAL_ID,J.NAME,J.OWNER_ID,R.FULL_NAME AS OWNER_NAME,J.EXTERNAL_KEY1,J.EXTERNAL_KEY2,J.URL,J.PROJECT_ID,P.NAME AS PROJECT_NAME
FROM  $(NF_SCHEMA).JOB J
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=J.OWNER_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=J.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_JOB_RESULT (JOB_RESULT_ID,REFERENCE_ID,EXTERNAL_ID,NAME,STATE,VERDICT, START_TIME,
END_TIME,DURATION,LAB_RESOURCE_ID,LAB_RESOURCE_NAME,OWNER_ID,OWNER_NAME,JOB_ID,JOB_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL) AS 
(SELECT J.JOB_RESULT_ID,J.REFERENCE_ID,J.EXTERNAL_ID,J.NAME,J.STATE,J.VERDICT, J.START_TIME,
J.END_TIME,J.DURATION,J.LAB_RESOURCE_ID,L.NAME AS LAB_RESOURCE_NAME,J.OWNER_ID,R.FULL_NAME AS OWNER_NAME,J.JOB_ID,JB.NAME AS JOB_NAME,
J.EXTERNAL_KEY1,J.EXTERNAL_KEY2,J.SOURCE_ID,J.URL
FROM  $(NF_SCHEMA).JOB_RESULT J
JOIN  $(NF_SCHEMA).JOB JB ON JB.JOB_ID=J.JOB_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=J.OWNER_ID
JOIN  $(NF_SCHEMA).LAB_RESOURCE L ON L.LAB_RESOURCE_ID=J.LAB_RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTIVITY_STATE_HISTORY (ACTIVITY_STATE_HISTORY_ID,ACTIVITY_ID,PREV_ACTIVITY_STATE,ACTIVITY_STATE,
CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT ACTIVITY_STATE_HISTORY_ID,ACTIVITY_ID,PREV_ACTIVITY_STATE,ACTIVITY_STATE,
CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2
FROM  $(NF_SCHEMA).ACTIVITY_STATE_HISTORY)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_STATE_HISTORY (TASK_STATE_HISTORY_ID,TASK_ID,PREV_TASK_STATE,TASK_STATE,
CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2) AS
(SELECT TASK_STATE_HISTORY_ID,TASK_ID,PREV_TASK_STATE,TASK_STATE,
CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2
FROM  $(NF_SCHEMA).TASK_STATE_HISTORY)
GO


