--******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

USE $(DBNAME)
GO

CREATE SCHEMA AUTHORIZATION $(STAR_SCHEMA)
GO

set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
GO
CREATE function $(STAR_SCHEMA).WEEK_OF_YEAR_ISO
	(
	@date	datetime
	)
returns		int
as

begin

declare @WeekOfYear		int

select
	
	@WeekOfYear =
	(datediff(dd,
	case
	when	NextYrStart <= @date
	then	NextYrStart
	when	CurrYrStart <= @date
	then	CurrYrStart
	else	PriorYrStart
	end,@date)/7)+1
from
	(
	select
		
		PriorYrStart =
		dateadd(dd,(datediff(dd,-53690,dateadd(yy,-1,aa.Jan4))/7)*7,-53690),
		CurrYrStart =
		dateadd(dd,(datediff(dd,-53690,aa.Jan4)/7)*7,-53690),
		NextYrStart =
		dateadd(dd,(datediff(dd,-53690,dateadd(yy,1,aa.Jan4))/7)*7,-53690)
	from
		(
		select
			Jan4	= 
			dateadd(dd,3,dateadd(yy,datediff(yy,0,@date),0))
		) aa
	) a

return @WeekOfYear

end

GO

CREATE PROCEDURE $(STAR_SCHEMA).POPULATE_D_DATE
@START_YEAR  INT, 
@END_YEAR INT, 
@SCHEMA_NAME NVARCHAR(8)

AS 
		
		DECLARE @MESSAGE_TEXT NVARCHAR(100);
		DECLARE @RETVAL INT;
               SET @RETVAL= 0;
		DECLARE @v_sqlstate NCHAR(5);
               SET @v_sqlstate= '00000';
        DECLARE @v_sqlcode INT;
                  SET @v_sqlstate= 0;
        DECLARE @v_errmsg NVARCHAR(100);
    	       SET @v_errmsg =''

		DECLARE @v_date_id INT;
		DECLARE @v_date datetime ;
		DECLARE @v_year_str NCHAR(4);                         
		DECLARE @v_year INT;
               SET @v_year=0 ;
		DECLARE @v_previous_year INT;
               SET @v_previous_year= 0 ;            
		DECLARE @v_quarter_of_year INT;
               SET @v_quarter_of_year= 0 ; 
		DECLARE @v_month_of_year INT;
               SET @v_month_of_year= 0;    
		DECLARE @v_month_name NVARCHAR(20);                
		DECLARE @v_week_of_year INT;
                 SET @v_week_of_year=0;   
		DECLARE @v_quarter_no INT;
                SET @v_quarter_no=0;       
		DECLARE @v_month_no INT;
                SET @v_month_no= 0;         
		DECLARE @v_week_no INT; 
                SET @v_week_no= 0; 
        DECLARE @v_week_no_iso INT; 
                SET @v_week_no_iso=0; 
		DECLARE @v_week_of_month INT; 
                SET @v_week_of_month=0;
        DECLARE @v_week_of_month_iso INT; 
                SET @v_week_of_month_iso=0;
		DECLARE @v_day_of_week INT;
                SET @v_day_of_week= 0;
		DECLARE @v_day_of_month INT;
                SET @v_day_of_month=0;
		DECLARE @v_day_of_year INT; 
                SET  @v_day_of_year=0;
		DECLARE @v_day_name NVARCHAR(20);
		DECLARE @v_previous_quarter INT; 
                SET @v_previous_quarter=0; 
		DECLARE @v_previous_month INT;
                SET @v_previous_month=0;   
		DECLARE @v_previous_week INT;
                SET @v_previous_week=0;  
        DECLARE @v_previous_week_iso INT;
                SET @v_previous_week_iso=0;  
		--DECLARE @v_calendar_type INT;
		--DECLARE @v_calendar_type_c NCHAR(1);
		DECLARE @v_schema_name NCHAR(8);
		DECLARE @stmt NVARCHAR(1000);
                SET @stmt=''; 
		DECLARE @v_print NVARCHAR(100); 
		DECLARE @v_min_date DATETIME;
		DECLARE @v_max_date DATETIME;
        DECLARE @v_week_of_year_iso INT;
        		SET @v_week_of_year_iso=0;
        DECLARE @v_day_of_week_iso INT;
        		SET @v_day_of_week_iso=0;
		
		-- Declare condition handlers
		
		--SET @v_calendar_type=@CALENDAR_TYPE;
       -- SET @v_calendar_type_c= CASE WHEN @v_calendar_type=1 THEN 'G' WHEN @v_calendar_type=2 THEN 'I' ELSE 'G' END;
		
       

        SET @v_schema_name=UPPER(RTRIM(@SCHEMA_NAME));
        IF @START_YEAR IS NULL OR @START_YEAR>@END_YEAR
         begin
          RAISERROR('$(CRREWMSGE087)',70004, 1) with log,nowait
			return ;
	     end 
		
		IF @END_YEAR IS NULL OR @END_YEAR < @START_YEAR 

	     begin
          RAISERROR('$(CRREWMSGE088)',70005, 1)  with log,nowait
			return ;
	     end 
		
	
    --	IF @v_calendar_type<>1 AND @v_calendar_type <> 2 
				 
       --  begin
       --   RAISERROR('Invalid calendar type. Specify 1 (gregorian), 2 (ISO)',70001, 1)  with log,nowait
	--		return ;
	--     end 
		
		
         IF (len(rtrim(@v_schema_name))=0)
				
		begin
          RAISERROR('$(CRREWMSGE089)',70006, 1)  with log,nowait
			return ;
	    end 

 
		SET @v_year_str=RTRIM(convert(nvarchar(8),@START_YEAR));

		SET @v_min_date=convert(datetime,convert(varchar,year(@v_year_str))+'-'+'01-01');
		SET @v_year_str=RTRIM(convert(nvarchar(8),@END_YEAR));
		SET @v_max_date= convert(datetime,convert(varchar,year(@v_year_str))+'-'+'12-31');

		SET @v_previous_year=@START_YEAR;
		SET @v_week_of_month=1;
		SET @v_day_of_month=0;
		
       
		print @v_week_of_year_iso
        print @v_day_of_week_iso
 
WHILE(@v_min_date<=@v_max_date) 
  begin
               SELECT @v_week_of_year_iso=$(STAR_SCHEMA).WEEK_OF_YEAR_ISO(@v_min_date)
		SET DATEFIRST 1
			SET @v_day_of_week_iso = datepart(dw, @v_min_date);
		SET DATEFIRST 7

	    	SET @v_year=YEAR(@v_min_date);
	    	SET @v_quarter_of_year=datepart(qq, @v_min_date);
	    	SET @v_month_of_year=MONTH(@v_min_date);
	    	SET @v_month_name=datename(mm, @v_min_date);
	    	SET @v_week_of_year=datepart(ww, @v_min_date);
	    	SET @v_week_of_year_iso=@v_week_of_year_iso;
	    	SET @v_quarter_no= CASE WHEN @v_quarter_of_year<>@v_previous_quarter THEN @v_quarter_no+1 ELSE @v_quarter_no END;
	    	SET @v_month_no= CASE WHEN @v_month_of_year<> @v_previous_month THEN @v_month_no+1 ELSE @v_month_no END;
	    	SET @v_week_no= CASE WHEN @v_week_of_year<>@v_previous_week THEN @v_week_no+1 ELSE @v_week_no END; 
	    	SET @v_week_no_iso= CASE WHEN @v_week_of_year_iso<>@v_previous_week_iso THEN @v_week_no_iso+1 ELSE @v_week_no_iso END;
			SET @v_day_of_week =datepart(dw, @v_min_date);
			SET @v_day_of_week_iso =@v_day_of_week_iso;
			SET @v_day_of_month=CASE WHEN @v_month_of_year<> @v_previous_month THEN 1 ELSE @v_day_of_month+1 END;
			SET @v_day_of_year =datepart(dy, @v_min_date);
			SET @v_day_name=datename(dw, @v_min_date);
			
		
	
--IF (@v_month_of_year<> @v_previous_month ) 
-- begin
--      IF (@v_calendar_type=1) 
--        SET @v_week_of_month=1;
--      ELSE
--   IF(@v_calendar_type=2 ) 
--         IF(@v_day_of_week<5) 
--           SET @v_week_of_month=1;
--         ELSE 
--     SET @v_week_of_month=0;
       
-- end
--else
-- IF (@v_day_of_week=1) 
--       SET @v_week_of_month=@v_week_of_month+1;	  
       
IF (@v_month_of_year<> @v_previous_month )
	begin
		SET @v_week_of_month=1;
		IF(@v_day_of_week_iso<5)
			SET @v_week_of_month_iso=1;
		ELSE SET @v_week_of_month_iso=0;
	end 
ELSE
	begin
	IF (@v_day_of_week=1)
		SET @v_week_of_month=@v_week_of_month+1;	
	IF (@v_day_of_week_iso=1)
		SET @v_week_of_month_iso=@v_week_of_month_iso+1;
	end
			       
       
SET @stmt='INSERT INTO ' + ltrim(rtrim(@v_schema_name)) +'.D_DATE (PERIOD_START_DATE,DAY_OF_WEEK ,DAY_OF_MONTH,DAY_OF_YEAR,DAY_NAME,WEEK_OF_MONTH ,WEEK_OF_YEAR,WEEK_NO,MONTH_OF_YEAR,MONTH_NAME,MONTH_NO,QUARTER_OF_YEAR,QUARTER_NO,YEAR_OF,DAY_OF_WEEK_ISO,WEEK_OF_MONTH_ISO,WEEK_OF_YEAR_ISO,WEEK_NO_ISO)'+ 
' VALUES( @v_min_date_,@v_day_of_week_,@v_day_of_month_,@v_day_of_year_,@v_day_name_,@v_week_of_month_,'+
'@v_week_of_year_,@v_week_no_,@v_month_of_year_,@v_month_name_,@v_month_no_,@v_quarter_of_year_,'+
'@v_quarter_no,@v_year_,@v_day_of_week_iso_,@v_week_of_month_iso_,@v_week_of_year_iso_,@v_week_no_iso_)';



      		EXECUTE sp_executesql @stmt,
			N'@v_min_date_ DATETIME,@v_day_of_week_ INT,@v_day_of_month_ INT,@v_day_of_year_ INT,@v_day_name_ NVARCHAR (10),@v_week_of_month_ INT ,@v_week_of_year_ INT,@v_week_no_ INT,@v_month_of_year_ INT ,@v_month_name_ NVARCHAR(10),@v_month_no_ INT,@v_quarter_of_year_ INT ,@v_quarter_no INT ,@v_year_ INT ,@v_day_of_week_iso_ INT,@v_week_of_month_iso_ INT ,@v_week_of_year_iso_ INT,@v_week_no_iso_ INT ',
            @v_min_date,@v_day_of_week,@v_day_of_month,@v_day_of_year,@v_day_name,@v_week_of_month,
            @v_week_of_year,@v_week_no,@v_month_of_year,@v_month_name,@v_month_no,@v_quarter_of_year,
            @v_quarter_no,@v_year,@v_day_of_week_iso,@v_week_of_month_iso,@v_week_of_year_iso,@v_week_no_iso;
     		
      		SET @v_previous_quarter=@v_quarter_of_year;
      		SET @v_previous_month=@v_month_of_year;
      		SET @v_previous_week=@v_week_of_year;
      		SET @v_previous_week_iso=@v_week_of_year_iso;
      		SET @v_min_date=@v_min_date+ 1;
 	END 
 	
 	--SET @stmt= 'UPDATE CONFIG.SYSCONFIG_INFO SET CHAR_VALUE ='+'''' + @v_calendar_type_c + ''''+' WHERE NAME='+''''+'CALENDAR_WEEK_TYPE'+'''';

   -- EXECUTE (@stmt);
 	return ;


GO





CREATE PROCEDURE $(STAR_SCHEMA).RECALCULATE_D_DATE 
@SCHEMA_NAME NCHAR(8)
AS

		DECLARE @v_total_rows INT;
		DECLARE @v_week_no INT; 
                SET @v_week_no=0;
        DECLARE @v_week_no_iso INT;
        		SET @v_week_no_iso =0; 
		DECLARE @v_month_no INT;
                SET @v_month_no =0;
		DECLARE @v_quarter_no INT; 
                SET @v_quarter_no=0;
		DECLARE @v_cur_week_no INT; 
                SET @v_cur_week_no=0;
        DECLARE @v_cur_week_no_iso INT;
                SET @v_cur_week_no_iso =0;
		DECLARE @v_cur_month_no INT; 
                SET @v_cur_month_no=0;
		DECLARE @v_cur_quarter_no INT; 
                SET @v_cur_quarter_no=0;
		DECLARE @v_prev_week_no INT; 
                SET @v_prev_week_no =0;
        DECLARE @v_prev_week_no_iso INT;
        		SET @v_prev_week_no_iso =0;
		DECLARE @v_prev_month_no INT;
                SET @v_prev_month_no=0;
		DECLARE @v_prev_quarter_no INT; 
                SET @v_prev_quarter_no=0;
		-- DECLARE @v_calendar_type INT;
		DECLARE @v_schema_name NCHAR(8);
		DECLARE @stmt NVARCHAR(1000);
              SET @stmt=''; 
        DECLARE @cur1 NVARCHAR(1000);
              SET @cur1=''; 
		DECLARE @stmt2 NVARCHAR(1000);
              SET @stmt2 ='';
        DECLARE @cur2 NVARCHAR(1000);
              SET @cur2=''; 
		DECLARE @v_cur_date DATETIME;
		DECLARE @v_prev_date DATETIME;
		DECLARE @no_rec INT;
                SET @no_rec =0;
		  
    SET @v_schema_name=ltrim(rtrim(@SCHEMA_NAME));

		SET @stmt='SELECT PERIOD_START_DATE,WEEK_OF_YEAR,WEEK_OF_YEAR_ISO,MONTH_OF_YEAR,QUARTER_OF_YEAR FROM ' +@v_schema_name+'.D_DATE ORDER BY PERIOD_START_DATE';
        SET @cur1= 'DECLARE CS1 CURSOR FOR '+@stmt
	    EXEC(@cur1)

								
				             OPEN CS1;
								FETCH CS1 INTO @v_cur_date,@v_cur_week_no,@v_cur_week_no_iso,@v_cur_month_no,@v_cur_quarter_no;
                                WHILE @@FETCH_STATUS = 0
                                  BEGIN
                                     FETCH CS1 INTO @v_cur_date,@v_cur_week_no,@v_cur_week_no_iso,@v_cur_month_no,@v_cur_quarter_no;
                                       FETCH NEXT FROM CS1;
                                      IF @v_cur_week_no<>@v_prev_week_no 
					                      BEGIN
                                             SET @v_week_no=@v_week_no+1;
					                         SET @v_prev_week_no=@v_cur_week_no;
                                          END;
                                      IF @v_cur_week_no_iso<>@v_prev_week_no_iso 
					                      BEGIN
                                             SET @v_week_no_iso=@v_week_no_iso+1;
					                         SET @v_prev_week_no_iso=@v_cur_week_no_iso;
                                          END;
                                          
				                      IF (@v_cur_month_no<>@v_prev_month_no) 
                                          BEGIN
					                         SET @v_month_no=@v_month_no+1;
					                         SET @v_prev_month_no=@v_cur_month_no;
					                      END;
					
					                  IF (@v_cur_quarter_no<>@v_prev_quarter_no) 
                                           BEGIN 
					                       SET @v_quarter_no=@v_quarter_no+1;
					                       SET @v_prev_quarter_no=@v_cur_quarter_no;
					                       END ;
					
					                  SET @stmt2='UPDATE '+@v_schema_name+'.D_DATE SET WEEK_NO=' +convert(varchar,@v_week_no)+ ',WEEK_NO_ISO=' +convert(varchar,@v_week_no_iso) + ', MONTH_NO='+convert(varchar,@v_month_no)+', QUARTER_NO='+convert(varchar,@v_quarter_no)+' WHERE PERIOD_START_DATE='+'''' +convert(varchar,@v_cur_date)+'''';
					
					                  EXECUTE (@stmt2);
					
                                  END
                             CLOSE CS1;
	                         DEALLOCATE CS1;					
	

	RETURN;

GO


--DROP PROCEDURE EXTEND_D_DATE@-
CREATE PROCEDURE $(STAR_SCHEMA).EXTEND_D_DATE 
@START_YEAR INT, @END_YEAR INT, 
 @SCHEMA_NAME NCHAR(8)
AS

Begin
	 
	DECLARE @SQLSTATE NCHAR(5);
		SET @SQLSTATE ='00000';         
	DECLARE @SQLCODE INT;
		SET @SQLCODE= 0;
	DECLARE @MESSAGE_TEXT NVARCHAR(100);
	DECLARE @RETVAL INT;
		SET  @RETVAL = 0; 
	DECLARE @v_sqlstate NCHAR(5);
		SET @v_sqlstate='00000';
	DECLARE @v_sqlcode INT;
		SET @v_sqlcode =0;
	DECLARE @v_errmsg NVARCHAR(100);
		SET @v_errmsg ='';

	DECLARE @v_total_rows INT;
	DECLARE @v_day_of_week INT;
		SET @v_day_of_week =0;
	DECLARE @v_day_name NVARCHAR(20);
	--DECLARE @v_calendar_type INT;
	DECLARE @v_schema_name NCHAR(8);
	DECLARE @stmt NVARCHAR(1000);
		SET @stmt=''; 
	DECLARE @cur1 NVARCHAR(1000);
		SET @cur1=''; 
	DECLARE @stmt2 NVARCHAR(1000);
		SET @stmt2 ='';
	DECLARE @cur2 NVARCHAR(1000);
		SET @cur2=''; 
        DECLARE @cur3 NVARCHAR(1000);
		SET @cur3=''; 
	DECLARE @v_min_year INT;
	
	DECLARE @v_max_year INT;
	DECLARE @v_min_date DATETIME;
	DECLARE @v_max_date DATETIME;
	DECLARE @v_min_date_v INT;
	     set @v_min_date_v =0;
	DECLARE @v_max_date_v INT;
		SET @v_max_date_v =0;

			
	SET @v_schema_name=UPPER(RTRIM(@SCHEMA_NAME));
		
	IF @START_YEAR IS NULL OR @START_YEAR>@END_YEAR 
	BEGIN
		RAISERROR('$(CRREWMSGE087)',70004, 1) with log,nowait; 
		ROLLBACK;
		RETURN;
	END 
	
	IF @END_YEAR IS NULL OR @END_YEAR < @START_YEAR 
	BEGIN
		RAISERROR('$(CRREWMSGE088)',70005, 1) with log,nowait ;
		ROLLBACK;
		RETURN ;
        END
		
	--IF @v_calendar_type<>1 AND @v_calendar_type <> 2 
	--BEGIN
	--	RAISERROR('$(CRREWMSGE086)',70001, 1) with log,nowait; 
	--	RETURN ;
        --END

	IF (len(rtrim(@v_schema_name))=0) 
	begin
		RAISERROR('$(CRREWMSGE089)',70006, 1)  with log,nowait;
		ROLLBACK;			
	return ;
	end 
		
		
	SET @v_min_year=@START_YEAR;
	SET @v_max_year=@END_YEAR;   

	SET @stmt= 'SELECT COUNT(*) FROM ' + ltrim(rtrim(@v_schema_name))+ '.D_DATE';
	SET @cur1 = 'DECLARE CS1 CURSOR FOR '+@stmt;

        EXECUTE (@cur1); 
 
	OPEN CS1
	FETCH NEXT FROM CS1 INTO @v_total_rows;

	WHILE @@FETCH_STATUS = 0
	BEGIN
		FETCH NEXT FROM CS1 INTO @v_total_rows;
		FETCH NEXT FROM CS1;
	END

	CLOSE CS1;
	DEALLOCATE CS1;			
    
   IF (@v_total_rows<>0) 
   BEGIN
   
   	SET @stmt='SELECT MIN(PERIOD_START_DATE), MAX(PERIOD_START_DATE) FROM ' + @v_schema_name + '.D_DATE ';
   								
   	  SET @cur3 = 'DECLARE CS3 CURSOR FOR '+@stmt;
   	  EXECUTE (@cur3);
          OPEN CS3					       
   	 FETCH NEXT FROM CS3 INTO @v_min_date,@v_max_date;
   	   WHILE @@FETCH_STATUS = 0
	  BEGIN
	         FETCH CS3 INTO @v_min_date,@v_max_date;
		 FETCH NEXT FROM CS3;
	  END
   	CLOSE CS3;
   	DEALLOCATE CS3;
   							 
   							  
   							  
   	IF DAY(@v_min_date)<>1 AND MONTH(@v_min_date)<>1
         RAISERROR( '$(CRREWMSGE090)',70010, 1) with log,nowait; 
     
   						    
   	IF DAY(@v_max_date)<>31 AND MONTH(@v_max_date)<>12
   	RAISERROR( '$(CRREWMSGE091)',70010, 1) with log,nowait; 
   	
   						    
   						    
   
   
  -- SET @stmt='SELECT INT_VALUE FROM CONFIG.SYSCONFIG_INFO WHERE NAME=''CALENDAR_WEEK_TYPE''';
	-- SET @cur3 = 'DECLARE CS3 CURSOR FOR '+@stmt;				   
						 
   -- EXECUTE (@cur3);
    
    -- OPEN CS3
   --  FETCH NEXT FROM CS3 INTO @v_calendar_type;
    
    -- WHILE @@FETCH_STATUS = 0
	-- BEGIN
		-- FETCH CS3 INTO @v_calendar_type;
		-- FETCH NEXT FROM CS3;
	-- END

	-- CLOSE CS3;
	-- EALLOCATE CS3;			


--backward extension

IF YEAR(@v_min_date)> @v_min_year
BEGIN
   IF YEAR(@v_min_date)> @v_max_year     
     BEGIN
     RAISERROR( '$(CRREWMSGE092)',70010, 1) with log,nowait; 
      ROLLBACK;			
      RETURN; 
    END
   ELSE 
      BEGIN 
      SET @v_min_date_V = year(@v_min_date)-1;
                            
      SET @stmt='EXEC '+ltrim(rtrim(@v_schema_name))+'.POPULATE_D_DATE ' +convert(varchar,@v_min_year)+','+convert(varchar,@v_min_date_v)+ ','+''''+ltrim(rtrim(@v_schema_name))+'''';
					
      EXECUTE  (@stmt);
      END
END
							  	

--        		               
						
--FORWARD extension
IF YEAR(@v_max_date)< @v_max_year
   BEGIN
    IF YEAR(@v_max_date)< (@v_min_year-1) 
       BEGIN
       RAISERROR('$(CRREWMSGE093)',70010, 1) with log,nowait; 
       ROLLBACK;			
       RETURN; 
    END
			
    ELSE
      BEGIN
      SET @v_max_date_v = YEAR(@v_max_date)+1;
      SET @stmt='EXEC ' +ltrim(rtrim(@v_schema_name))+ '.POPULATE_D_DATE ' + convert(varchar,@v_max_date_v) + ', '+convert(varchar,@v_max_year)+ ', '+''''+ltrim(rtrim(@v_schema_name))+'''';
      EXECUTE (@stmt);
    END 
END        		 
   
SET @stmt2='EXEC ' +ltrim(rtrim(@v_schema_name))+'.RECALCULATE_D_DATE '+'''' +ltrim(rtrim(@v_schema_name))+'''';
   EXECUTE (@stmt2);	
		
END 
END 
RETURN; 
GO

--DROP FUNCTION SELECT_ETL_DATE
CREATE FUNCTION $(STAR_SCHEMA).SELECT_ETL_DATE 
(@ETLGRANULARITY INT, 
@ETLDATE datetime,
@CAL_TYPE INT)
RETURNS INT 
AS 
BEGIN 
     DECLARE @v_date_id INT
     SET @v_date_id = -1
	 DECLARE @v_cal_type NCHAR(1)
     SET @v_cal_type=''
	 DECLARE @stmt NVARCHAR(1000)
     SET @stmt='' 
	 SET @v_cal_type=CASE WHEN @CAL_TYPE =1 THEN 'G' ELSE 'I' END
	 -- SET @v_date_id=
     DECLARE @ETLDATE_ISO INT
    
     SELECT @ETLDATE_ISO =$(STAR_SCHEMA).WEEK_OF_YEAR_ISO(@ETLDATE );
	 IF @ETLGRANULARITY =1
     SELECT @v_date_id= DATE_ID FROM $(STAR_SCHEMA).D_DATE WHERE PERIOD_START_DATE= convert(datetime, convert(varchar, @ETLDATE, 110))
	 ELSE IF @ETLGRANULARITY =2
     begin
      if @v_cal_type='I'
      SELECT @v_date_id = DATE_ID FROM $(STAR_SCHEMA).D_WEEK WHERE  WEEK_OF_YEAR= @ETLDATE_ISO and YEAR_OF=YEAR(@ETLDATE)
      else 
      SELECT @v_date_id = DATE_ID FROM $(STAR_SCHEMA).D_WEEK WHERE  WEEK_OF_YEAR=datepart(ww, @ETLDATE) and YEAR_OF=YEAR(@ETLDATE)
     end
      --  SELECT DATE_ID FROM D_WEEK WHERE WEEK_OF_YEAR=(CASE WHEN @v_cal_type='I' THEN WEEK_ISO(@ETLDATE) ELSE WEEK(@ETLDATE) END) AND YEAR_OF=YEAR(@ETLDATE))
    ELSE IF @ETLGRANULARITY =3
      SELECT @v_date_id = DATE_ID FROM $(STAR_SCHEMA).D_MONTH WHERE MONTH_OF_YEAR=MONTH(@ETLDATE) AND YEAR_OF=YEAR(@ETLDATE)

RETURN @v_date_id
END	 
GO





